System.register(['@builder.io/react', '@builder.io/app-context'], function () {
    'use strict';
    var Builder, appState;
    return {
        setters: [function (module) {
            Builder = module.Builder;
        }, function (module) {
            appState = module.default;
        }],
        execute: function () {

            /*! *****************************************************************************
            Copyright (c) Microsoft Corporation.

            Permission to use, copy, modify, and/or distribute this software for any
            purpose with or without fee is hereby granted.

            THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
            REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
            AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
            INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
            LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
            OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
            PERFORMANCE OF THIS SOFTWARE.
            ***************************************************************************** */

            var __assign = function() {
                __assign = Object.assign || function __assign(t) {
                    for (var s, i = 1, n = arguments.length; i < n; i++) {
                        s = arguments[i];
                        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
                    }
                    return t;
                };
                return __assign.apply(this, arguments);
            };

            function __awaiter$3(thisArg, _arguments, P, generator) {
                function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
                return new (P || (P = Promise))(function (resolve, reject) {
                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
                    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
                    step((generator = generator.apply(thisArg, _arguments || [])).next());
                });
            }

            function __generator$1(thisArg, body) {
                var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
                return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
                function verb(n) { return function (v) { return step([n, v]); }; }
                function step(op) {
                    if (f) throw new TypeError("Generator is already executing.");
                    while (_) try {
                        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                        if (y = 0, t) op = [op[0] & 2, t.value];
                        switch (op[0]) {
                            case 0: case 1: t = op; break;
                            case 4: _.label++; return { value: op[1], done: false };
                            case 5: _.label++; y = op[1]; op = [0]; continue;
                            case 7: op = _.ops.pop(); _.trys.pop(); continue;
                            default:
                                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                                if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                                if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                                if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                                if (t[2]) _.ops.pop();
                                _.trys.pop(); continue;
                        }
                        op = body.call(thisArg, _);
                    } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
                    if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
                }
            }

            var registerDataPlugin = function (config, apiOperationsFromSettings) { return __awaiter$3(void 0, void 0, void 0, function () {
                var registerEditors, onSave, savedSettings;
                return __generator$1(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            registerEditors = function () { return __awaiter$3(void 0, void 0, void 0, function () {
                                var savedSettings, allSettings, _a;
                                return __generator$1(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            savedSettings = appState.user.organization.value.settings.plugins.get(config.id);
                                            _a = [__assign({}, config)];
                                            return [4 /*yield*/, apiOperationsFromSettings(savedSettings)];
                                        case 1:
                                            allSettings = __assign.apply(void 0, _a.concat([_b.sent()]));
                                            appState.registerDataPlugin(allSettings);
                                            return [2 /*return*/];
                                    }
                                });
                            }); };
                            onSave = config.onSave;
                            config.onSave = function (actions) { return __awaiter$3(void 0, void 0, void 0, function () {
                                return __generator$1(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, actions.updateSettings({ hasConnected: true })];
                                        case 1:
                                            _a.sent();
                                            if (!onSave) return [3 /*break*/, 3];
                                            return [4 /*yield*/, onSave(actions)];
                                        case 2:
                                            _a.sent();
                                            _a.label = 3;
                                        case 3:
                                            registerEditors();
                                            return [2 /*return*/];
                                    }
                                });
                            }); };
                            Builder.register('plugin', __assign(__assign({}, config), { isDataPlugin: true }));
                            Builder.register('app.onLoad', function (_a) {
                                var triggerSettingsDialog = _a.triggerSettingsDialog;
                                return __awaiter$3(void 0, void 0, void 0, function () {
                                    var pluginSettings, hasConnected;
                                    var _b;
                                    return __generator$1(this, function (_c) {
                                        switch (_c.label) {
                                            case 0:
                                                pluginSettings = appState.user.organization.value.settings.plugins.get(config.id);
                                                hasConnected = (_b = pluginSettings) === null || _b === void 0 ? void 0 : _b.get('hasConnected');
                                                if (!!hasConnected) return [3 /*break*/, 2];
                                                return [4 /*yield*/, triggerSettingsDialog(config.id)];
                                            case 1:
                                                _c.sent();
                                                _c.label = 2;
                                            case 2: return [2 /*return*/];
                                        }
                                    });
                                });
                            });
                            savedSettings = appState.user.organization.value.settings.plugins.get(config.id);
                            if (!savedSettings) {
                                return [2 /*return*/];
                            }
                            return [4 /*yield*/, registerEditors()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); };

            var name = "@builder.io/plugin-kontent-ai";
            var version = "0.0.2-0";
            var description = "";
            var keywords = [
            ];
            var main = "dist/plugin.system.js";
            var unpkg = "dist/plugin.system.js";
            var files = [
            	"dist"
            ];
            var author = "Steve Sewell <steve@builder.io>";
            var repository = {
            	type: "git",
            	url: ""
            };
            var license = "MIT";
            var engines = {
            	node: ">=6.0.0"
            };
            var scripts = {
            	postinstall: "patch-package",
            	lint: "tslint  --project tsconfig.json -t codeFrame 'src/**/*.ts' 'test/**/*.ts'",
            	prebuild: "rimraf dist",
            	build: "rollup -c rollup.config.ts",
            	"release:patch": "npm run build && npm version patch --no-git-tag-version && npm publish",
            	"release:dev": "npm run build && npm version prerelease --no-git-tag-version && npm publish --tag dev",
            	start: "cross-env SERVE=true rollup -c rollup.config.ts -w",
            	test: "jest --coverage",
            	"test:watch": "jest --coverage --watch",
            	"test:prod": "npm run lint && npm run test -- --no-cache",
            	"deploy-docs": "ts-node tools/gh-pages-publish",
            	"report-coverage": "cat ./coverage/lcov.info | coveralls",
            	commit: "git-cz",
            	"semantic-release": "semantic-release",
            	"semantic-release-prepare": "ts-node tools/semantic-release-prepare",
            	"travis-deploy-once": "travis-deploy-once"
            };
            var config = {
            	commitizen: {
            		path: "node_modules/cz-conventional-changelog"
            	}
            };
            var jest = {
            	transform: {
            		".(ts|tsx)": "ts-jest"
            	},
            	testEnvironment: "node",
            	testRegex: "(/__tests__/.*|\\.(test|spec))\\.(ts|tsx|js)$",
            	moduleFileExtensions: [
            		"ts",
            		"tsx",
            		"js"
            	],
            	coveragePathIgnorePatterns: [
            		"/node_modules/",
            		"/test/"
            	],
            	coverageThreshold: {
            		global: {
            			branches: 90,
            			functions: 95,
            			lines: 95,
            			statements: 95
            		}
            	},
            	collectCoverageFrom: [
            		"src/*.{js,ts}"
            	]
            };
            var commitlint = {
            	"extends": [
            		"@commitlint/config-conventional"
            	]
            };
            var devDependencies = {
            	"@builder.io/react": "^1.1.29",
            	"@commitlint/cli": "^7.1.2",
            	"@commitlint/config-conventional": "^7.1.2",
            	"@rollup/plugin-commonjs": "^19.0.1",
            	"@rollup/plugin-json": "^4.1.0",
            	"@rollup/plugin-node-resolve": "^13.0.2",
            	"@types/chec__commerce.js": "^2.7.2",
            	"@types/jest": "^23.3.2",
            	"@types/node": "^10.17.5",
            	"@types/qs": "^6.9.7",
            	"@types/react": "^16.9.11",
            	"@types/shopify-buy": "^2.10.4",
            	colors: "^1.3.2",
            	commitizen: "^3.0.0",
            	coveralls: "^3.0.2",
            	"cross-env": "^5.2.1",
            	"cz-conventional-changelog": "^2.1.0",
            	esbuild: "^0.12.15",
            	husky: "^1.0.1",
            	i: "^0.3.6",
            	jest: "^23.6.0",
            	"jest-config": "^23.6.0",
            	"lint-staged": "^8.0.0",
            	"lodash.camelcase": "^4.3.0",
            	"patch-package": "^6.4.7",
            	prettier: "^1.14.3",
            	prompt: "^1.0.0",
            	"replace-in-file": "^3.4.2",
            	rimraf: "^2.6.2",
            	rollup: "^2.53.2",
            	"rollup-plugin-dts": "^3.0.2",
            	"rollup-plugin-esbuild": "^4.5.0",
            	"rollup-plugin-node-globals": "^1.4.0",
            	"rollup-plugin-node-polyfills": "^0.2.1",
            	"rollup-plugin-replace": "^2.2.0",
            	"rollup-plugin-serve": "^1.0.1",
            	"semantic-release": "^15.9.16",
            	shelljs: "^0.8.3",
            	"travis-deploy-once": "^5.0.9",
            	"ts-jest": "^23.10.2",
            	"ts-node": "^7.0.1",
            	tslint: "^5.11.0",
            	"tslint-config-prettier": "^1.15.0",
            	"tslint-config-standard": "^8.0.1",
            	typedoc: "^0.12.0",
            	typescript: "^3.0.3"
            };
            var dependencies = {
            	"@builder.io/data-plugin-tools": "0.0.3-0",
            	"@chec/commerce.js": "^2.7.2",
            	"@kentico/kontent-delivery": "11.6.0",
            	qs: "^6.10.1"
            };
            var pkg = {
            	name: name,
            	version: version,
            	description: description,
            	keywords: keywords,
            	main: main,
            	unpkg: unpkg,
            	files: files,
            	author: author,
            	repository: repository,
            	license: license,
            	engines: engines,
            	scripts: scripts,
            	"lint-staged": {
            	"{src,test}/**/*.ts": [
            		"prettier --write",
            		"git add"
            	]
            },
            	config: config,
            	jest: jest,
            	commitlint: commitlint,
            	devDependencies: devDependencies,
            	dependencies: dependencies
            };

            var UrlHelper = /** @class */ (function () {
                function UrlHelper() {
                }
                /**
               * Adds query parameters to given url
               * @param url Url to which options will be added
               * @param options Query parameters to add
               */
                UrlHelper.prototype.addOptionsToUrl = function (url, options) {
                    if (options) {
                        options.forEach(function (filter) {
                            if (url.indexOf('?') > -1) {
                                url += '&';
                            }
                            else {
                                url += '?';
                            }
                            url += filter.getParam();
                        });
                    }
                    return url;
                };
                return UrlHelper;
            }());
            var urlHelper = new UrlHelper();

            /*! *****************************************************************************
            Copyright (c) Microsoft Corporation. All rights reserved.
            Licensed under the Apache License, Version 2.0 (the "License"); you may not use
            this file except in compliance with the License. You may obtain a copy of the
            License at http://www.apache.org/licenses/LICENSE-2.0

            THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
            KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
            WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
            MERCHANTABLITY OR NON-INFRINGEMENT.

            See the Apache Version 2.0 License for specific language governing permissions
            and limitations under the License.
            ***************************************************************************** */

            function __awaiter$2(thisArg, _arguments, P, generator) {
                return new (P || (P = Promise))(function (resolve, reject) {
                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
                    function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
                    step((generator = generator.apply(thisArg, _arguments || [])).next());
                });
            }

            function __generator(thisArg, body) {
                var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
                return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
                function verb(n) { return function (v) { return step([n, v]); }; }
                function step(op) {
                    if (f) throw new TypeError("Generator is already executing.");
                    while (_) try {
                        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                        if (y = 0, t) op = [op[0] & 2, t.value];
                        switch (op[0]) {
                            case 0: case 1: t = op; break;
                            case 4: _.label++; return { value: op[1], done: false };
                            case 5: _.label++; y = op[1]; op = [0]; continue;
                            case 7: op = _.ops.pop(); _.trys.pop(); continue;
                            default:
                                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                                if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                                if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                                if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                                if (t[2]) _.ops.pop();
                                _.trys.pop(); continue;
                        }
                        op = body.call(thisArg, _);
                    } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
                    if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
                }
            }

            function __values(o) {
                var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
                if (m) return m.call(o);
                return {
                    next: function () {
                        if (o && i >= o.length) o = void 0;
                        return { value: o && o[i++], done: !o };
                    }
                };
            }

            var EnumHelper = /** @class */ (function () {
                function EnumHelper() {
                }
                EnumHelper.prototype.getAllNames = function (T) {
                    var enumNames = [];
                    for (var key in T) {
                        if (T.hasOwnProperty(key)) {
                            enumNames.push(key);
                        }
                    }
                    return enumNames;
                };
                EnumHelper.prototype.getAllValues = function (T) {
                    var allEnumValues = Object.keys(T).map(function (key) { return T[key]; });
                    return allEnumValues;
                };
                EnumHelper.prototype.getEnumFromValue = function (T, value) {
                    try {
                        if (!value) {
                            return undefined;
                        }
                        // we can map back from index number directly
                        if (this.isNumeric(value)) {
                            return T[value];
                        }
                        // for strings, we need to compare each value separately
                        var allEnumValues = this.getAllValues(T);
                        var result = allEnumValues.find(function (m) { return m.toLowerCase() === value.toString().toLowerCase(); });
                        if (!result) {
                            return undefined;
                        }
                        return result;
                    }
                    catch (err) {
                        return undefined;
                    }
                };
                EnumHelper.prototype.getEnumFromName = function (T, name) {
                    var e_1, _a;
                    var allNames = this.getAllNames(T);
                    try {
                        for (var allNames_1 = __values(allNames), allNames_1_1 = allNames_1.next(); !allNames_1_1.done; allNames_1_1 = allNames_1.next()) {
                            var enumName = allNames_1_1.value;
                            if (enumName.toLowerCase() === name.toLowerCase()) {
                                return T[enumName];
                            }
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (allNames_1_1 && !allNames_1_1.done && (_a = allNames_1.return)) _a.call(allNames_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                    return undefined;
                };
                EnumHelper.prototype.isNumeric = function (value) {
                    return !isNaN(parseFloat(value)) && isFinite(value);
                };
                return EnumHelper;
            }());
            var enumHelper = new EnumHelper();

            function extractHeadersFromAxiosResponse(response) {
                var e_1, _a;
                var headers = [];
                try {
                    for (var _b = __values(Object.keys(response.headers)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var headerKey = _c.value;
                        headers.push({
                            header: headerKey,
                            value: response.headers[headerKey]
                        });
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                return headers;
            }

            var RetryHelper = /** @class */ (function () {
                function RetryHelper() {
                    var _this = this;
                    this.requestCancelledMessagePrefix = 'Request cancelled';
                    this.retryAfterHeaderName = 'Retry-After';
                    this.defaultRetryStatusCodes = [408, 429, 500, 502, 503, 504];
                    this.defaultRetryStrategy = {
                        addJitter: true,
                        deltaBackoffMs: 1000,
                        maxAttempts: 5,
                        canRetryError: function (error) { return _this.canRetryErrorDefault(error); }
                    };
                }
                RetryHelper.prototype.getRetryErrorResult = function (data) {
                    var _a, _b, _c;
                    if (data.error && data.error.message) {
                        if (data.error.message.startsWith(this.requestCancelledMessagePrefix)) {
                            // request was cancelled by user, do not retry it
                            return {
                                canRetry: false,
                                retryInMs: 0,
                                maxRetries: 0
                            };
                        }
                    }
                    var canRetryError = data.retryStrategy.canRetryError
                        ? data.retryStrategy.canRetryError(data.error)
                        : this.defaultRetryStrategy.canRetryError(data.error);
                    if (!canRetryError) {
                        // request cannot be retried
                        return {
                            canRetry: false,
                            retryInMs: 0,
                            maxRetries: 0
                        };
                    }
                    var maxRetries = ((_a = data.retryStrategy.maxAttempts) !== null && _a !== void 0 ? _a : this.defaultRetryStrategy.maxAttempts);
                    var maxRetriesReached = data.retryAttempt >= maxRetries;
                    if (maxRetriesReached) {
                        // request cannot be retried anymore due to maximum attempts
                        return {
                            canRetry: false,
                            retryInMs: 0,
                            maxRetries: maxRetries
                        };
                    }
                    // get wait time
                    var retryResult = this.tryGetRetryAfterInMsFromError(data.error);
                    if (retryResult) {
                        // retry after header was provided
                        return {
                            canRetry: true,
                            retryInMs: retryResult,
                            maxRetries: maxRetries
                        };
                    }
                    // wait time was not provided in header
                    var waitTimeMs = this.getNextWaitTimeMs((_b = data.retryStrategy.addJitter) !== null && _b !== void 0 ? _b : this.defaultRetryStrategy.addJitter, (_c = data.retryStrategy.deltaBackoffMs) !== null && _c !== void 0 ? _c : this.defaultRetryStrategy.deltaBackoffMs, data.retryAttempt);
                    return {
                        canRetry: true,
                        retryInMs: waitTimeMs,
                        maxRetries: maxRetries
                    };
                };
                RetryHelper.prototype.getRetryStrategyFromStrategyOptions = function (retryOptions) {
                    if (!retryOptions) {
                        return this.defaultRetryStrategy;
                    }
                    return retryOptions;
                };
                RetryHelper.prototype.canRetryInTime = function (startTime, maxCumulativeWaitTimeMs) {
                    var start = startTime.getTime();
                    var now = new Date().getTime();
                    var differenceInMs = now - start;
                    return {
                        canRetry: differenceInMs < maxCumulativeWaitTimeMs,
                        differenceInMs: differenceInMs
                    };
                };
                RetryHelper.prototype.getNextWaitTimeMs = function (addJitter, deltaBackoffMs, retryAttempts) {
                    if (!addJitter) {
                        return deltaBackoffMs * Math.pow(2, retryAttempts);
                    }
                    var from = 0.8 * deltaBackoffMs;
                    var to = 1.2 * deltaBackoffMs * Math.pow(2, retryAttempts);
                    return this.randomNumberFromInterval(from, to);
                };
                RetryHelper.prototype.canRetryErrorDefault = function (error) {
                    var axiosError = this.tryGetAxiosError(error);
                    if (!axiosError) {
                        // by default non-axios errors are not retried
                        return false;
                    }
                    var statusCode = this.getStatusCodeFromError(error);
                    var canRetryStatusCode = this.canRetryStatusCode(statusCode, this.defaultRetryStatusCodes);
                    if (canRetryStatusCode) {
                        return true;
                    }
                    return false;
                };
                RetryHelper.prototype.tryGetRetryAfterInMsFromError = function (error) {
                    var _this = this;
                    var axiosError = this.tryGetAxiosError(error);
                    if (!axiosError || !axiosError.response) {
                        return undefined;
                    }
                    var headers = extractHeadersFromAxiosResponse(axiosError.response);
                    var retryValueHeader = headers.find(function (m) { return m.header.toLowerCase() === _this.retryAfterHeaderName.toLowerCase(); });
                    if (!retryValueHeader) {
                        return undefined;
                    }
                    var retryInSeconds = +retryValueHeader.value;
                    return retryInSeconds * 1000;
                };
                RetryHelper.prototype.canRetryStatusCode = function (statusCode, useRetryForResponseCodes) {
                    return useRetryForResponseCodes.includes(statusCode);
                };
                RetryHelper.prototype.getStatusCodeFromError = function (error) {
                    var axiosError = this.tryGetAxiosError(error);
                    if (!axiosError || !axiosError.response) {
                        return 0;
                    }
                    return axiosError.response.status;
                };
                RetryHelper.prototype.tryGetAxiosError = function (error) {
                    if (!error) {
                        return undefined;
                    }
                    if (error.isAxiosError) {
                        return error;
                    }
                    var originalError = error.originalError;
                    if (originalError && originalError.isAxiosError) {
                        return originalError;
                    }
                    return undefined;
                };
                /**
                 * min and max included
                 */
                RetryHelper.prototype.randomNumberFromInterval = function (min, max) {
                    return Math.floor(Math.random() * (max - min + 1) + min);
                };
                return RetryHelper;
            }());
            var retryHelper = new RetryHelper();

            var Parameters$1;
            (function (Parameters) {
                var CustomParameter = /** @class */ (function () {
                    /**
                     * Custom parameter
                     * @constructor
                     * @param {string} name - Name of the parameter
                     * @param {string} value - Value of the parameter
                     */
                    function CustomParameter(name, value) {
                        this.name = name;
                        this.value = value;
                        if (!name) {
                            throw Error("Name of the custom parameter is not specified");
                        }
                    }
                    CustomParameter.prototype.getParam = function () {
                        return this.name;
                    };
                    CustomParameter.prototype.getParamValue = function () {
                        return this.value;
                    };
                    return CustomParameter;
                }());
                Parameters.CustomParameter = CustomParameter;
            })(Parameters$1 || (Parameters$1 = {}));

            var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

            var axios$2 = {exports: {}};

            var bind$2 = function bind(fn, thisArg) {
              return function wrap() {
                var args = new Array(arguments.length);
                for (var i = 0; i < args.length; i++) {
                  args[i] = arguments[i];
                }
                return fn.apply(thisArg, args);
              };
            };

            var bind$1 = bind$2;

            // utils is a library of generic helper functions non-specific to axios

            var toString$1 = Object.prototype.toString;

            /**
             * Determine if a value is an Array
             *
             * @param {Object} val The value to test
             * @returns {boolean} True if value is an Array, otherwise false
             */
            function isArray(val) {
              return Array.isArray(val);
            }

            /**
             * Determine if a value is undefined
             *
             * @param {Object} val The value to test
             * @returns {boolean} True if the value is undefined, otherwise false
             */
            function isUndefined(val) {
              return typeof val === 'undefined';
            }

            /**
             * Determine if a value is a Buffer
             *
             * @param {Object} val The value to test
             * @returns {boolean} True if value is a Buffer, otherwise false
             */
            function isBuffer(val) {
              return val !== null && !isUndefined(val) && val.constructor !== null && !isUndefined(val.constructor)
                && typeof val.constructor.isBuffer === 'function' && val.constructor.isBuffer(val);
            }

            /**
             * Determine if a value is an ArrayBuffer
             *
             * @param {Object} val The value to test
             * @returns {boolean} True if value is an ArrayBuffer, otherwise false
             */
            function isArrayBuffer(val) {
              return toString$1.call(val) === '[object ArrayBuffer]';
            }

            /**
             * Determine if a value is a FormData
             *
             * @param {Object} val The value to test
             * @returns {boolean} True if value is an FormData, otherwise false
             */
            function isFormData(val) {
              return toString$1.call(val) === '[object FormData]';
            }

            /**
             * Determine if a value is a view on an ArrayBuffer
             *
             * @param {Object} val The value to test
             * @returns {boolean} True if value is a view on an ArrayBuffer, otherwise false
             */
            function isArrayBufferView(val) {
              var result;
              if ((typeof ArrayBuffer !== 'undefined') && (ArrayBuffer.isView)) {
                result = ArrayBuffer.isView(val);
              } else {
                result = (val) && (val.buffer) && (isArrayBuffer(val.buffer));
              }
              return result;
            }

            /**
             * Determine if a value is a String
             *
             * @param {Object} val The value to test
             * @returns {boolean} True if value is a String, otherwise false
             */
            function isString(val) {
              return typeof val === 'string';
            }

            /**
             * Determine if a value is a Number
             *
             * @param {Object} val The value to test
             * @returns {boolean} True if value is a Number, otherwise false
             */
            function isNumber(val) {
              return typeof val === 'number';
            }

            /**
             * Determine if a value is an Object
             *
             * @param {Object} val The value to test
             * @returns {boolean} True if value is an Object, otherwise false
             */
            function isObject(val) {
              return val !== null && typeof val === 'object';
            }

            /**
             * Determine if a value is a plain Object
             *
             * @param {Object} val The value to test
             * @return {boolean} True if value is a plain Object, otherwise false
             */
            function isPlainObject(val) {
              if (toString$1.call(val) !== '[object Object]') {
                return false;
              }

              var prototype = Object.getPrototypeOf(val);
              return prototype === null || prototype === Object.prototype;
            }

            /**
             * Determine if a value is a Date
             *
             * @param {Object} val The value to test
             * @returns {boolean} True if value is a Date, otherwise false
             */
            function isDate(val) {
              return toString$1.call(val) === '[object Date]';
            }

            /**
             * Determine if a value is a File
             *
             * @param {Object} val The value to test
             * @returns {boolean} True if value is a File, otherwise false
             */
            function isFile(val) {
              return toString$1.call(val) === '[object File]';
            }

            /**
             * Determine if a value is a Blob
             *
             * @param {Object} val The value to test
             * @returns {boolean} True if value is a Blob, otherwise false
             */
            function isBlob(val) {
              return toString$1.call(val) === '[object Blob]';
            }

            /**
             * Determine if a value is a Function
             *
             * @param {Object} val The value to test
             * @returns {boolean} True if value is a Function, otherwise false
             */
            function isFunction(val) {
              return toString$1.call(val) === '[object Function]';
            }

            /**
             * Determine if a value is a Stream
             *
             * @param {Object} val The value to test
             * @returns {boolean} True if value is a Stream, otherwise false
             */
            function isStream(val) {
              return isObject(val) && isFunction(val.pipe);
            }

            /**
             * Determine if a value is a URLSearchParams object
             *
             * @param {Object} val The value to test
             * @returns {boolean} True if value is a URLSearchParams object, otherwise false
             */
            function isURLSearchParams(val) {
              return toString$1.call(val) === '[object URLSearchParams]';
            }

            /**
             * Trim excess whitespace off the beginning and end of a string
             *
             * @param {String} str The String to trim
             * @returns {String} The String freed of excess whitespace
             */
            function trim(str) {
              return str.trim ? str.trim() : str.replace(/^\s+|\s+$/g, '');
            }

            /**
             * Determine if we're running in a standard browser environment
             *
             * This allows axios to run in a web worker, and react-native.
             * Both environments support XMLHttpRequest, but not fully standard globals.
             *
             * web workers:
             *  typeof window -> undefined
             *  typeof document -> undefined
             *
             * react-native:
             *  navigator.product -> 'ReactNative'
             * nativescript
             *  navigator.product -> 'NativeScript' or 'NS'
             */
            function isStandardBrowserEnv() {
              if (typeof navigator !== 'undefined' && (navigator.product === 'ReactNative' ||
                                                       navigator.product === 'NativeScript' ||
                                                       navigator.product === 'NS')) {
                return false;
              }
              return (
                typeof window !== 'undefined' &&
                typeof document !== 'undefined'
              );
            }

            /**
             * Iterate over an Array or an Object invoking a function for each item.
             *
             * If `obj` is an Array callback will be called passing
             * the value, index, and complete array for each item.
             *
             * If 'obj' is an Object callback will be called passing
             * the value, key, and complete object for each property.
             *
             * @param {Object|Array} obj The object to iterate
             * @param {Function} fn The callback to invoke for each item
             */
            function forEach(obj, fn) {
              // Don't bother if no value provided
              if (obj === null || typeof obj === 'undefined') {
                return;
              }

              // Force an array if not already something iterable
              if (typeof obj !== 'object') {
                /*eslint no-param-reassign:0*/
                obj = [obj];
              }

              if (isArray(obj)) {
                // Iterate over array values
                for (var i = 0, l = obj.length; i < l; i++) {
                  fn.call(null, obj[i], i, obj);
                }
              } else {
                // Iterate over object keys
                for (var key in obj) {
                  if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    fn.call(null, obj[key], key, obj);
                  }
                }
              }
            }

            /**
             * Accepts varargs expecting each argument to be an object, then
             * immutably merges the properties of each object and returns result.
             *
             * When multiple objects contain the same key the later object in
             * the arguments list will take precedence.
             *
             * Example:
             *
             * ```js
             * var result = merge({foo: 123}, {foo: 456});
             * console.log(result.foo); // outputs 456
             * ```
             *
             * @param {Object} obj1 Object to merge
             * @returns {Object} Result of all merge properties
             */
            function merge(/* obj1, obj2, obj3, ... */) {
              var result = {};
              function assignValue(val, key) {
                if (isPlainObject(result[key]) && isPlainObject(val)) {
                  result[key] = merge(result[key], val);
                } else if (isPlainObject(val)) {
                  result[key] = merge({}, val);
                } else if (isArray(val)) {
                  result[key] = val.slice();
                } else {
                  result[key] = val;
                }
              }

              for (var i = 0, l = arguments.length; i < l; i++) {
                forEach(arguments[i], assignValue);
              }
              return result;
            }

            /**
             * Extends object a by mutably adding to it the properties of object b.
             *
             * @param {Object} a The object to be extended
             * @param {Object} b The object to copy properties from
             * @param {Object} thisArg The object to bind function to
             * @return {Object} The resulting value of object a
             */
            function extend(a, b, thisArg) {
              forEach(b, function assignValue(val, key) {
                if (thisArg && typeof val === 'function') {
                  a[key] = bind$1(val, thisArg);
                } else {
                  a[key] = val;
                }
              });
              return a;
            }

            /**
             * Remove byte order marker. This catches EF BB BF (the UTF-8 BOM)
             *
             * @param {string} content with BOM
             * @return {string} content value without BOM
             */
            function stripBOM(content) {
              if (content.charCodeAt(0) === 0xFEFF) {
                content = content.slice(1);
              }
              return content;
            }

            var utils$e = {
              isArray: isArray,
              isArrayBuffer: isArrayBuffer,
              isBuffer: isBuffer,
              isFormData: isFormData,
              isArrayBufferView: isArrayBufferView,
              isString: isString,
              isNumber: isNumber,
              isObject: isObject,
              isPlainObject: isPlainObject,
              isUndefined: isUndefined,
              isDate: isDate,
              isFile: isFile,
              isBlob: isBlob,
              isFunction: isFunction,
              isStream: isStream,
              isURLSearchParams: isURLSearchParams,
              isStandardBrowserEnv: isStandardBrowserEnv,
              forEach: forEach,
              merge: merge,
              extend: extend,
              trim: trim,
              stripBOM: stripBOM
            };

            var utils$d = utils$e;

            function encode$1(val) {
              return encodeURIComponent(val).
                replace(/%3A/gi, ':').
                replace(/%24/g, '$').
                replace(/%2C/gi, ',').
                replace(/%20/g, '+').
                replace(/%5B/gi, '[').
                replace(/%5D/gi, ']');
            }

            /**
             * Build a URL by appending params to the end
             *
             * @param {string} url The base of the url (e.g., http://www.google.com)
             * @param {object} [params] The params to be appended
             * @returns {string} The formatted url
             */
            var buildURL$2 = function buildURL(url, params, paramsSerializer) {
              /*eslint no-param-reassign:0*/
              if (!params) {
                return url;
              }

              var serializedParams;
              if (paramsSerializer) {
                serializedParams = paramsSerializer(params);
              } else if (utils$d.isURLSearchParams(params)) {
                serializedParams = params.toString();
              } else {
                var parts = [];

                utils$d.forEach(params, function serialize(val, key) {
                  if (val === null || typeof val === 'undefined') {
                    return;
                  }

                  if (utils$d.isArray(val)) {
                    key = key + '[]';
                  } else {
                    val = [val];
                  }

                  utils$d.forEach(val, function parseValue(v) {
                    if (utils$d.isDate(v)) {
                      v = v.toISOString();
                    } else if (utils$d.isObject(v)) {
                      v = JSON.stringify(v);
                    }
                    parts.push(encode$1(key) + '=' + encode$1(v));
                  });
                });

                serializedParams = parts.join('&');
              }

              if (serializedParams) {
                var hashmarkIndex = url.indexOf('#');
                if (hashmarkIndex !== -1) {
                  url = url.slice(0, hashmarkIndex);
                }

                url += (url.indexOf('?') === -1 ? '?' : '&') + serializedParams;
              }

              return url;
            };

            var utils$c = utils$e;

            function InterceptorManager$1() {
              this.handlers = [];
            }

            /**
             * Add a new interceptor to the stack
             *
             * @param {Function} fulfilled The function to handle `then` for a `Promise`
             * @param {Function} rejected The function to handle `reject` for a `Promise`
             *
             * @return {Number} An ID used to remove interceptor later
             */
            InterceptorManager$1.prototype.use = function use(fulfilled, rejected, options) {
              this.handlers.push({
                fulfilled: fulfilled,
                rejected: rejected,
                synchronous: options ? options.synchronous : false,
                runWhen: options ? options.runWhen : null
              });
              return this.handlers.length - 1;
            };

            /**
             * Remove an interceptor from the stack
             *
             * @param {Number} id The ID that was returned by `use`
             */
            InterceptorManager$1.prototype.eject = function eject(id) {
              if (this.handlers[id]) {
                this.handlers[id] = null;
              }
            };

            /**
             * Iterate over all the registered interceptors
             *
             * This method is particularly useful for skipping over any
             * interceptors that may have become `null` calling `eject`.
             *
             * @param {Function} fn The function to call for each interceptor
             */
            InterceptorManager$1.prototype.forEach = function forEach(fn) {
              utils$c.forEach(this.handlers, function forEachHandler(h) {
                if (h !== null) {
                  fn(h);
                }
              });
            };

            var InterceptorManager_1 = InterceptorManager$1;

            var utils$b = utils$e;

            var normalizeHeaderName$1 = function normalizeHeaderName(headers, normalizedName) {
              utils$b.forEach(headers, function processHeader(value, name) {
                if (name !== normalizedName && name.toUpperCase() === normalizedName.toUpperCase()) {
                  headers[normalizedName] = value;
                  delete headers[name];
                }
              });
            };

            /**
             * Update an Error with the specified config, error code, and response.
             *
             * @param {Error} error The error to update.
             * @param {Object} config The config.
             * @param {string} [code] The error code (for example, 'ECONNABORTED').
             * @param {Object} [request] The request.
             * @param {Object} [response] The response.
             * @returns {Error} The error.
             */
            var enhanceError$2 = function enhanceError(error, config, code, request, response) {
              error.config = config;
              if (code) {
                error.code = code;
              }

              error.request = request;
              error.response = response;
              error.isAxiosError = true;

              error.toJSON = function toJSON() {
                return {
                  // Standard
                  message: this.message,
                  name: this.name,
                  // Microsoft
                  description: this.description,
                  number: this.number,
                  // Mozilla
                  fileName: this.fileName,
                  lineNumber: this.lineNumber,
                  columnNumber: this.columnNumber,
                  stack: this.stack,
                  // Axios
                  config: this.config,
                  code: this.code,
                  status: this.response && this.response.status ? this.response.status : null
                };
              };
              return error;
            };

            var transitional = {
              silentJSONParsing: true,
              forcedJSONParsing: true,
              clarifyTimeoutError: false
            };

            var enhanceError$1 = enhanceError$2;

            /**
             * Create an Error with the specified message, config, error code, request and response.
             *
             * @param {string} message The error message.
             * @param {Object} config The config.
             * @param {string} [code] The error code (for example, 'ECONNABORTED').
             * @param {Object} [request] The request.
             * @param {Object} [response] The response.
             * @returns {Error} The created error.
             */
            var createError$2 = function createError(message, config, code, request, response) {
              var error = new Error(message);
              return enhanceError$1(error, config, code, request, response);
            };

            var createError$1 = createError$2;

            /**
             * Resolve or reject a Promise based on response status.
             *
             * @param {Function} resolve A function that resolves the promise.
             * @param {Function} reject A function that rejects the promise.
             * @param {object} response The response.
             */
            var settle$1 = function settle(resolve, reject, response) {
              var validateStatus = response.config.validateStatus;
              if (!response.status || !validateStatus || validateStatus(response.status)) {
                resolve(response);
              } else {
                reject(createError$1(
                  'Request failed with status code ' + response.status,
                  response.config,
                  null,
                  response.request,
                  response
                ));
              }
            };

            var utils$a = utils$e;

            var cookies$1 = (
              utils$a.isStandardBrowserEnv() ?

              // Standard browser envs support document.cookie
                (function standardBrowserEnv() {
                  return {
                    write: function write(name, value, expires, path, domain, secure) {
                      var cookie = [];
                      cookie.push(name + '=' + encodeURIComponent(value));

                      if (utils$a.isNumber(expires)) {
                        cookie.push('expires=' + new Date(expires).toGMTString());
                      }

                      if (utils$a.isString(path)) {
                        cookie.push('path=' + path);
                      }

                      if (utils$a.isString(domain)) {
                        cookie.push('domain=' + domain);
                      }

                      if (secure === true) {
                        cookie.push('secure');
                      }

                      document.cookie = cookie.join('; ');
                    },

                    read: function read(name) {
                      var match = document.cookie.match(new RegExp('(^|;\\s*)(' + name + ')=([^;]*)'));
                      return (match ? decodeURIComponent(match[3]) : null);
                    },

                    remove: function remove(name) {
                      this.write(name, '', Date.now() - 86400000);
                    }
                  };
                })() :

              // Non standard browser env (web workers, react-native) lack needed support.
                (function nonStandardBrowserEnv() {
                  return {
                    write: function write() {},
                    read: function read() { return null; },
                    remove: function remove() {}
                  };
                })()
            );

            /**
             * Determines whether the specified URL is absolute
             *
             * @param {string} url The URL to test
             * @returns {boolean} True if the specified URL is absolute, otherwise false
             */
            var isAbsoluteURL$1 = function isAbsoluteURL(url) {
              // A URL is considered absolute if it begins with "<scheme>://" or "//" (protocol-relative URL).
              // RFC 3986 defines scheme name as a sequence of characters beginning with a letter and followed
              // by any combination of letters, digits, plus, period, or hyphen.
              return /^([a-z][a-z\d+\-.]*:)?\/\//i.test(url);
            };

            /**
             * Creates a new URL by combining the specified URLs
             *
             * @param {string} baseURL The base URL
             * @param {string} relativeURL The relative URL
             * @returns {string} The combined URL
             */
            var combineURLs$1 = function combineURLs(baseURL, relativeURL) {
              return relativeURL
                ? baseURL.replace(/\/+$/, '') + '/' + relativeURL.replace(/^\/+/, '')
                : baseURL;
            };

            var isAbsoluteURL = isAbsoluteURL$1;
            var combineURLs = combineURLs$1;

            /**
             * Creates a new URL by combining the baseURL with the requestedURL,
             * only when the requestedURL is not already an absolute URL.
             * If the requestURL is absolute, this function returns the requestedURL untouched.
             *
             * @param {string} baseURL The base URL
             * @param {string} requestedURL Absolute or relative URL to combine
             * @returns {string} The combined full path
             */
            var buildFullPath$1 = function buildFullPath(baseURL, requestedURL) {
              if (baseURL && !isAbsoluteURL(requestedURL)) {
                return combineURLs(baseURL, requestedURL);
              }
              return requestedURL;
            };

            var utils$9 = utils$e;

            // Headers whose duplicates are ignored by node
            // c.f. https://nodejs.org/api/http.html#http_message_headers
            var ignoreDuplicateOf = [
              'age', 'authorization', 'content-length', 'content-type', 'etag',
              'expires', 'from', 'host', 'if-modified-since', 'if-unmodified-since',
              'last-modified', 'location', 'max-forwards', 'proxy-authorization',
              'referer', 'retry-after', 'user-agent'
            ];

            /**
             * Parse headers into an object
             *
             * ```
             * Date: Wed, 27 Aug 2014 08:58:49 GMT
             * Content-Type: application/json
             * Connection: keep-alive
             * Transfer-Encoding: chunked
             * ```
             *
             * @param {String} headers Headers needing to be parsed
             * @returns {Object} Headers parsed into an object
             */
            var parseHeaders$1 = function parseHeaders(headers) {
              var parsed = {};
              var key;
              var val;
              var i;

              if (!headers) { return parsed; }

              utils$9.forEach(headers.split('\n'), function parser(line) {
                i = line.indexOf(':');
                key = utils$9.trim(line.substr(0, i)).toLowerCase();
                val = utils$9.trim(line.substr(i + 1));

                if (key) {
                  if (parsed[key] && ignoreDuplicateOf.indexOf(key) >= 0) {
                    return;
                  }
                  if (key === 'set-cookie') {
                    parsed[key] = (parsed[key] ? parsed[key] : []).concat([val]);
                  } else {
                    parsed[key] = parsed[key] ? parsed[key] + ', ' + val : val;
                  }
                }
              });

              return parsed;
            };

            var utils$8 = utils$e;

            var isURLSameOrigin$1 = (
              utils$8.isStandardBrowserEnv() ?

              // Standard browser envs have full support of the APIs needed to test
              // whether the request URL is of the same origin as current location.
                (function standardBrowserEnv() {
                  var msie = /(msie|trident)/i.test(navigator.userAgent);
                  var urlParsingNode = document.createElement('a');
                  var originURL;

                  /**
                * Parse a URL to discover it's components
                *
                * @param {String} url The URL to be parsed
                * @returns {Object}
                */
                  function resolveURL(url) {
                    var href = url;

                    if (msie) {
                    // IE needs attribute set twice to normalize properties
                      urlParsingNode.setAttribute('href', href);
                      href = urlParsingNode.href;
                    }

                    urlParsingNode.setAttribute('href', href);

                    // urlParsingNode provides the UrlUtils interface - http://url.spec.whatwg.org/#urlutils
                    return {
                      href: urlParsingNode.href,
                      protocol: urlParsingNode.protocol ? urlParsingNode.protocol.replace(/:$/, '') : '',
                      host: urlParsingNode.host,
                      search: urlParsingNode.search ? urlParsingNode.search.replace(/^\?/, '') : '',
                      hash: urlParsingNode.hash ? urlParsingNode.hash.replace(/^#/, '') : '',
                      hostname: urlParsingNode.hostname,
                      port: urlParsingNode.port,
                      pathname: (urlParsingNode.pathname.charAt(0) === '/') ?
                        urlParsingNode.pathname :
                        '/' + urlParsingNode.pathname
                    };
                  }

                  originURL = resolveURL(window.location.href);

                  /**
                * Determine if a URL shares the same origin as the current location
                *
                * @param {String} requestURL The URL to test
                * @returns {boolean} True if URL shares the same origin, otherwise false
                */
                  return function isURLSameOrigin(requestURL) {
                    var parsed = (utils$8.isString(requestURL)) ? resolveURL(requestURL) : requestURL;
                    return (parsed.protocol === originURL.protocol &&
                        parsed.host === originURL.host);
                  };
                })() :

              // Non standard browser envs (web workers, react-native) lack needed support.
                (function nonStandardBrowserEnv() {
                  return function isURLSameOrigin() {
                    return true;
                  };
                })()
            );

            /**
             * A `Cancel` is an object that is thrown when an operation is canceled.
             *
             * @class
             * @param {string=} message The message.
             */
            function Cancel$3(message) {
              this.message = message;
            }

            Cancel$3.prototype.toString = function toString() {
              return 'Cancel' + (this.message ? ': ' + this.message : '');
            };

            Cancel$3.prototype.__CANCEL__ = true;

            var Cancel_1 = Cancel$3;

            var utils$7 = utils$e;
            var settle = settle$1;
            var cookies = cookies$1;
            var buildURL$1 = buildURL$2;
            var buildFullPath = buildFullPath$1;
            var parseHeaders = parseHeaders$1;
            var isURLSameOrigin = isURLSameOrigin$1;
            var createError = createError$2;
            var transitionalDefaults$1 = transitional;
            var Cancel$2 = Cancel_1;

            var xhr = function xhrAdapter(config) {
              return new Promise(function dispatchXhrRequest(resolve, reject) {
                var requestData = config.data;
                var requestHeaders = config.headers;
                var responseType = config.responseType;
                var onCanceled;
                function done() {
                  if (config.cancelToken) {
                    config.cancelToken.unsubscribe(onCanceled);
                  }

                  if (config.signal) {
                    config.signal.removeEventListener('abort', onCanceled);
                  }
                }

                if (utils$7.isFormData(requestData)) {
                  delete requestHeaders['Content-Type']; // Let the browser set it
                }

                var request = new XMLHttpRequest();

                // HTTP basic authentication
                if (config.auth) {
                  var username = config.auth.username || '';
                  var password = config.auth.password ? unescape(encodeURIComponent(config.auth.password)) : '';
                  requestHeaders.Authorization = 'Basic ' + btoa(username + ':' + password);
                }

                var fullPath = buildFullPath(config.baseURL, config.url);
                request.open(config.method.toUpperCase(), buildURL$1(fullPath, config.params, config.paramsSerializer), true);

                // Set the request timeout in MS
                request.timeout = config.timeout;

                function onloadend() {
                  if (!request) {
                    return;
                  }
                  // Prepare the response
                  var responseHeaders = 'getAllResponseHeaders' in request ? parseHeaders(request.getAllResponseHeaders()) : null;
                  var responseData = !responseType || responseType === 'text' ||  responseType === 'json' ?
                    request.responseText : request.response;
                  var response = {
                    data: responseData,
                    status: request.status,
                    statusText: request.statusText,
                    headers: responseHeaders,
                    config: config,
                    request: request
                  };

                  settle(function _resolve(value) {
                    resolve(value);
                    done();
                  }, function _reject(err) {
                    reject(err);
                    done();
                  }, response);

                  // Clean up request
                  request = null;
                }

                if ('onloadend' in request) {
                  // Use onloadend if available
                  request.onloadend = onloadend;
                } else {
                  // Listen for ready state to emulate onloadend
                  request.onreadystatechange = function handleLoad() {
                    if (!request || request.readyState !== 4) {
                      return;
                    }

                    // The request errored out and we didn't get a response, this will be
                    // handled by onerror instead
                    // With one exception: request that using file: protocol, most browsers
                    // will return status as 0 even though it's a successful request
                    if (request.status === 0 && !(request.responseURL && request.responseURL.indexOf('file:') === 0)) {
                      return;
                    }
                    // readystate handler is calling before onerror or ontimeout handlers,
                    // so we should call onloadend on the next 'tick'
                    setTimeout(onloadend);
                  };
                }

                // Handle browser request cancellation (as opposed to a manual cancellation)
                request.onabort = function handleAbort() {
                  if (!request) {
                    return;
                  }

                  reject(createError('Request aborted', config, 'ECONNABORTED', request));

                  // Clean up request
                  request = null;
                };

                // Handle low level network errors
                request.onerror = function handleError() {
                  // Real errors are hidden from us by the browser
                  // onerror should only fire if it's a network error
                  reject(createError('Network Error', config, null, request));

                  // Clean up request
                  request = null;
                };

                // Handle timeout
                request.ontimeout = function handleTimeout() {
                  var timeoutErrorMessage = config.timeout ? 'timeout of ' + config.timeout + 'ms exceeded' : 'timeout exceeded';
                  var transitional = config.transitional || transitionalDefaults$1;
                  if (config.timeoutErrorMessage) {
                    timeoutErrorMessage = config.timeoutErrorMessage;
                  }
                  reject(createError(
                    timeoutErrorMessage,
                    config,
                    transitional.clarifyTimeoutError ? 'ETIMEDOUT' : 'ECONNABORTED',
                    request));

                  // Clean up request
                  request = null;
                };

                // Add xsrf header
                // This is only done if running in a standard browser environment.
                // Specifically not if we're in a web worker, or react-native.
                if (utils$7.isStandardBrowserEnv()) {
                  // Add xsrf header
                  var xsrfValue = (config.withCredentials || isURLSameOrigin(fullPath)) && config.xsrfCookieName ?
                    cookies.read(config.xsrfCookieName) :
                    undefined;

                  if (xsrfValue) {
                    requestHeaders[config.xsrfHeaderName] = xsrfValue;
                  }
                }

                // Add headers to the request
                if ('setRequestHeader' in request) {
                  utils$7.forEach(requestHeaders, function setRequestHeader(val, key) {
                    if (typeof requestData === 'undefined' && key.toLowerCase() === 'content-type') {
                      // Remove Content-Type if data is undefined
                      delete requestHeaders[key];
                    } else {
                      // Otherwise add header to the request
                      request.setRequestHeader(key, val);
                    }
                  });
                }

                // Add withCredentials to request if needed
                if (!utils$7.isUndefined(config.withCredentials)) {
                  request.withCredentials = !!config.withCredentials;
                }

                // Add responseType to request if needed
                if (responseType && responseType !== 'json') {
                  request.responseType = config.responseType;
                }

                // Handle progress if needed
                if (typeof config.onDownloadProgress === 'function') {
                  request.addEventListener('progress', config.onDownloadProgress);
                }

                // Not all browsers support upload events
                if (typeof config.onUploadProgress === 'function' && request.upload) {
                  request.upload.addEventListener('progress', config.onUploadProgress);
                }

                if (config.cancelToken || config.signal) {
                  // Handle cancellation
                  // eslint-disable-next-line func-names
                  onCanceled = function(cancel) {
                    if (!request) {
                      return;
                    }
                    reject(!cancel || (cancel && cancel.type) ? new Cancel$2('canceled') : cancel);
                    request.abort();
                    request = null;
                  };

                  config.cancelToken && config.cancelToken.subscribe(onCanceled);
                  if (config.signal) {
                    config.signal.aborted ? onCanceled() : config.signal.addEventListener('abort', onCanceled);
                  }
                }

                if (!requestData) {
                  requestData = null;
                }

                // Send the request
                request.send(requestData);
              });
            };

            var utils$6 = utils$e;
            var normalizeHeaderName = normalizeHeaderName$1;
            var enhanceError = enhanceError$2;
            var transitionalDefaults = transitional;

            var DEFAULT_CONTENT_TYPE = {
              'Content-Type': 'application/x-www-form-urlencoded'
            };

            function setContentTypeIfUnset(headers, value) {
              if (!utils$6.isUndefined(headers) && utils$6.isUndefined(headers['Content-Type'])) {
                headers['Content-Type'] = value;
              }
            }

            function getDefaultAdapter() {
              var adapter;
              if (typeof XMLHttpRequest !== 'undefined') {
                // For browsers use XHR adapter
                adapter = xhr;
              } else if (typeof process !== 'undefined' && Object.prototype.toString.call(process) === '[object process]') {
                // For node use HTTP adapter
                adapter = xhr;
              }
              return adapter;
            }

            function stringifySafely(rawValue, parser, encoder) {
              if (utils$6.isString(rawValue)) {
                try {
                  (parser || JSON.parse)(rawValue);
                  return utils$6.trim(rawValue);
                } catch (e) {
                  if (e.name !== 'SyntaxError') {
                    throw e;
                  }
                }
              }

              return (encoder || JSON.stringify)(rawValue);
            }

            var defaults$3 = {

              transitional: transitionalDefaults,

              adapter: getDefaultAdapter(),

              transformRequest: [function transformRequest(data, headers) {
                normalizeHeaderName(headers, 'Accept');
                normalizeHeaderName(headers, 'Content-Type');

                if (utils$6.isFormData(data) ||
                  utils$6.isArrayBuffer(data) ||
                  utils$6.isBuffer(data) ||
                  utils$6.isStream(data) ||
                  utils$6.isFile(data) ||
                  utils$6.isBlob(data)
                ) {
                  return data;
                }
                if (utils$6.isArrayBufferView(data)) {
                  return data.buffer;
                }
                if (utils$6.isURLSearchParams(data)) {
                  setContentTypeIfUnset(headers, 'application/x-www-form-urlencoded;charset=utf-8');
                  return data.toString();
                }
                if (utils$6.isObject(data) || (headers && headers['Content-Type'] === 'application/json')) {
                  setContentTypeIfUnset(headers, 'application/json');
                  return stringifySafely(data);
                }
                return data;
              }],

              transformResponse: [function transformResponse(data) {
                var transitional = this.transitional || defaults$3.transitional;
                var silentJSONParsing = transitional && transitional.silentJSONParsing;
                var forcedJSONParsing = transitional && transitional.forcedJSONParsing;
                var strictJSONParsing = !silentJSONParsing && this.responseType === 'json';

                if (strictJSONParsing || (forcedJSONParsing && utils$6.isString(data) && data.length)) {
                  try {
                    return JSON.parse(data);
                  } catch (e) {
                    if (strictJSONParsing) {
                      if (e.name === 'SyntaxError') {
                        throw enhanceError(e, this, 'E_JSON_PARSE');
                      }
                      throw e;
                    }
                  }
                }

                return data;
              }],

              /**
               * A timeout in milliseconds to abort a request. If set to 0 (default) a
               * timeout is not created.
               */
              timeout: 0,

              xsrfCookieName: 'XSRF-TOKEN',
              xsrfHeaderName: 'X-XSRF-TOKEN',

              maxContentLength: -1,
              maxBodyLength: -1,

              validateStatus: function validateStatus(status) {
                return status >= 200 && status < 300;
              },

              headers: {
                common: {
                  'Accept': 'application/json, text/plain, */*'
                }
              }
            };

            utils$6.forEach(['delete', 'get', 'head'], function forEachMethodNoData(method) {
              defaults$3.headers[method] = {};
            });

            utils$6.forEach(['post', 'put', 'patch'], function forEachMethodWithData(method) {
              defaults$3.headers[method] = utils$6.merge(DEFAULT_CONTENT_TYPE);
            });

            var defaults_1 = defaults$3;

            var utils$5 = utils$e;
            var defaults$2 = defaults_1;

            /**
             * Transform the data for a request or a response
             *
             * @param {Object|String} data The data to be transformed
             * @param {Array} headers The headers for the request or response
             * @param {Array|Function} fns A single function or Array of functions
             * @returns {*} The resulting transformed data
             */
            var transformData$1 = function transformData(data, headers, fns) {
              var context = this || defaults$2;
              /*eslint no-param-reassign:0*/
              utils$5.forEach(fns, function transform(fn) {
                data = fn.call(context, data, headers);
              });

              return data;
            };

            var isCancel$1 = function isCancel(value) {
              return !!(value && value.__CANCEL__);
            };

            var utils$4 = utils$e;
            var transformData = transformData$1;
            var isCancel = isCancel$1;
            var defaults$1 = defaults_1;
            var Cancel$1 = Cancel_1;

            /**
             * Throws a `Cancel` if cancellation has been requested.
             */
            function throwIfCancellationRequested(config) {
              if (config.cancelToken) {
                config.cancelToken.throwIfRequested();
              }

              if (config.signal && config.signal.aborted) {
                throw new Cancel$1('canceled');
              }
            }

            /**
             * Dispatch a request to the server using the configured adapter.
             *
             * @param {object} config The config that is to be used for the request
             * @returns {Promise} The Promise to be fulfilled
             */
            var dispatchRequest$1 = function dispatchRequest(config) {
              throwIfCancellationRequested(config);

              // Ensure headers exist
              config.headers = config.headers || {};

              // Transform request data
              config.data = transformData.call(
                config,
                config.data,
                config.headers,
                config.transformRequest
              );

              // Flatten headers
              config.headers = utils$4.merge(
                config.headers.common || {},
                config.headers[config.method] || {},
                config.headers
              );

              utils$4.forEach(
                ['delete', 'get', 'head', 'post', 'put', 'patch', 'common'],
                function cleanHeaderConfig(method) {
                  delete config.headers[method];
                }
              );

              var adapter = config.adapter || defaults$1.adapter;

              return adapter(config).then(function onAdapterResolution(response) {
                throwIfCancellationRequested(config);

                // Transform response data
                response.data = transformData.call(
                  config,
                  response.data,
                  response.headers,
                  config.transformResponse
                );

                return response;
              }, function onAdapterRejection(reason) {
                if (!isCancel(reason)) {
                  throwIfCancellationRequested(config);

                  // Transform response data
                  if (reason && reason.response) {
                    reason.response.data = transformData.call(
                      config,
                      reason.response.data,
                      reason.response.headers,
                      config.transformResponse
                    );
                  }
                }

                return Promise.reject(reason);
              });
            };

            var utils$3 = utils$e;

            /**
             * Config-specific merge-function which creates a new config-object
             * by merging two configuration objects together.
             *
             * @param {Object} config1
             * @param {Object} config2
             * @returns {Object} New object resulting from merging config2 to config1
             */
            var mergeConfig$2 = function mergeConfig(config1, config2) {
              // eslint-disable-next-line no-param-reassign
              config2 = config2 || {};
              var config = {};

              function getMergedValue(target, source) {
                if (utils$3.isPlainObject(target) && utils$3.isPlainObject(source)) {
                  return utils$3.merge(target, source);
                } else if (utils$3.isPlainObject(source)) {
                  return utils$3.merge({}, source);
                } else if (utils$3.isArray(source)) {
                  return source.slice();
                }
                return source;
              }

              // eslint-disable-next-line consistent-return
              function mergeDeepProperties(prop) {
                if (!utils$3.isUndefined(config2[prop])) {
                  return getMergedValue(config1[prop], config2[prop]);
                } else if (!utils$3.isUndefined(config1[prop])) {
                  return getMergedValue(undefined, config1[prop]);
                }
              }

              // eslint-disable-next-line consistent-return
              function valueFromConfig2(prop) {
                if (!utils$3.isUndefined(config2[prop])) {
                  return getMergedValue(undefined, config2[prop]);
                }
              }

              // eslint-disable-next-line consistent-return
              function defaultToConfig2(prop) {
                if (!utils$3.isUndefined(config2[prop])) {
                  return getMergedValue(undefined, config2[prop]);
                } else if (!utils$3.isUndefined(config1[prop])) {
                  return getMergedValue(undefined, config1[prop]);
                }
              }

              // eslint-disable-next-line consistent-return
              function mergeDirectKeys(prop) {
                if (prop in config2) {
                  return getMergedValue(config1[prop], config2[prop]);
                } else if (prop in config1) {
                  return getMergedValue(undefined, config1[prop]);
                }
              }

              var mergeMap = {
                'url': valueFromConfig2,
                'method': valueFromConfig2,
                'data': valueFromConfig2,
                'baseURL': defaultToConfig2,
                'transformRequest': defaultToConfig2,
                'transformResponse': defaultToConfig2,
                'paramsSerializer': defaultToConfig2,
                'timeout': defaultToConfig2,
                'timeoutMessage': defaultToConfig2,
                'withCredentials': defaultToConfig2,
                'adapter': defaultToConfig2,
                'responseType': defaultToConfig2,
                'xsrfCookieName': defaultToConfig2,
                'xsrfHeaderName': defaultToConfig2,
                'onUploadProgress': defaultToConfig2,
                'onDownloadProgress': defaultToConfig2,
                'decompress': defaultToConfig2,
                'maxContentLength': defaultToConfig2,
                'maxBodyLength': defaultToConfig2,
                'transport': defaultToConfig2,
                'httpAgent': defaultToConfig2,
                'httpsAgent': defaultToConfig2,
                'cancelToken': defaultToConfig2,
                'socketPath': defaultToConfig2,
                'responseEncoding': defaultToConfig2,
                'validateStatus': mergeDirectKeys
              };

              utils$3.forEach(Object.keys(config1).concat(Object.keys(config2)), function computeConfigValue(prop) {
                var merge = mergeMap[prop] || mergeDeepProperties;
                var configValue = merge(prop);
                (utils$3.isUndefined(configValue) && merge !== mergeDirectKeys) || (config[prop] = configValue);
              });

              return config;
            };

            var data = {
              "version": "0.26.1"
            };

            var VERSION = data.version;

            var validators$1 = {};

            // eslint-disable-next-line func-names
            ['object', 'boolean', 'number', 'function', 'string', 'symbol'].forEach(function(type, i) {
              validators$1[type] = function validator(thing) {
                return typeof thing === type || 'a' + (i < 1 ? 'n ' : ' ') + type;
              };
            });

            var deprecatedWarnings = {};

            /**
             * Transitional option validator
             * @param {function|boolean?} validator - set to false if the transitional option has been removed
             * @param {string?} version - deprecated version / removed since version
             * @param {string?} message - some message with additional info
             * @returns {function}
             */
            validators$1.transitional = function transitional(validator, version, message) {
              function formatMessage(opt, desc) {
                return '[Axios v' + VERSION + '] Transitional option \'' + opt + '\'' + desc + (message ? '. ' + message : '');
              }

              // eslint-disable-next-line func-names
              return function(value, opt, opts) {
                if (validator === false) {
                  throw new Error(formatMessage(opt, ' has been removed' + (version ? ' in ' + version : '')));
                }

                if (version && !deprecatedWarnings[opt]) {
                  deprecatedWarnings[opt] = true;
                  // eslint-disable-next-line no-console
                  console.warn(
                    formatMessage(
                      opt,
                      ' has been deprecated since v' + version + ' and will be removed in the near future'
                    )
                  );
                }

                return validator ? validator(value, opt, opts) : true;
              };
            };

            /**
             * Assert object's properties type
             * @param {object} options
             * @param {object} schema
             * @param {boolean?} allowUnknown
             */

            function assertOptions(options, schema, allowUnknown) {
              if (typeof options !== 'object') {
                throw new TypeError('options must be an object');
              }
              var keys = Object.keys(options);
              var i = keys.length;
              while (i-- > 0) {
                var opt = keys[i];
                var validator = schema[opt];
                if (validator) {
                  var value = options[opt];
                  var result = value === undefined || validator(value, opt, options);
                  if (result !== true) {
                    throw new TypeError('option ' + opt + ' must be ' + result);
                  }
                  continue;
                }
                if (allowUnknown !== true) {
                  throw Error('Unknown option ' + opt);
                }
              }
            }

            var validator$1 = {
              assertOptions: assertOptions,
              validators: validators$1
            };

            var utils$2 = utils$e;
            var buildURL = buildURL$2;
            var InterceptorManager = InterceptorManager_1;
            var dispatchRequest = dispatchRequest$1;
            var mergeConfig$1 = mergeConfig$2;
            var validator = validator$1;

            var validators = validator.validators;
            /**
             * Create a new instance of Axios
             *
             * @param {Object} instanceConfig The default config for the instance
             */
            function Axios$1(instanceConfig) {
              this.defaults = instanceConfig;
              this.interceptors = {
                request: new InterceptorManager(),
                response: new InterceptorManager()
              };
            }

            /**
             * Dispatch a request
             *
             * @param {Object} config The config specific for this request (merged with this.defaults)
             */
            Axios$1.prototype.request = function request(configOrUrl, config) {
              /*eslint no-param-reassign:0*/
              // Allow for axios('example/url'[, config]) a la fetch API
              if (typeof configOrUrl === 'string') {
                config = config || {};
                config.url = configOrUrl;
              } else {
                config = configOrUrl || {};
              }

              config = mergeConfig$1(this.defaults, config);

              // Set config.method
              if (config.method) {
                config.method = config.method.toLowerCase();
              } else if (this.defaults.method) {
                config.method = this.defaults.method.toLowerCase();
              } else {
                config.method = 'get';
              }

              var transitional = config.transitional;

              if (transitional !== undefined) {
                validator.assertOptions(transitional, {
                  silentJSONParsing: validators.transitional(validators.boolean),
                  forcedJSONParsing: validators.transitional(validators.boolean),
                  clarifyTimeoutError: validators.transitional(validators.boolean)
                }, false);
              }

              // filter out skipped interceptors
              var requestInterceptorChain = [];
              var synchronousRequestInterceptors = true;
              this.interceptors.request.forEach(function unshiftRequestInterceptors(interceptor) {
                if (typeof interceptor.runWhen === 'function' && interceptor.runWhen(config) === false) {
                  return;
                }

                synchronousRequestInterceptors = synchronousRequestInterceptors && interceptor.synchronous;

                requestInterceptorChain.unshift(interceptor.fulfilled, interceptor.rejected);
              });

              var responseInterceptorChain = [];
              this.interceptors.response.forEach(function pushResponseInterceptors(interceptor) {
                responseInterceptorChain.push(interceptor.fulfilled, interceptor.rejected);
              });

              var promise;

              if (!synchronousRequestInterceptors) {
                var chain = [dispatchRequest, undefined];

                Array.prototype.unshift.apply(chain, requestInterceptorChain);
                chain = chain.concat(responseInterceptorChain);

                promise = Promise.resolve(config);
                while (chain.length) {
                  promise = promise.then(chain.shift(), chain.shift());
                }

                return promise;
              }


              var newConfig = config;
              while (requestInterceptorChain.length) {
                var onFulfilled = requestInterceptorChain.shift();
                var onRejected = requestInterceptorChain.shift();
                try {
                  newConfig = onFulfilled(newConfig);
                } catch (error) {
                  onRejected(error);
                  break;
                }
              }

              try {
                promise = dispatchRequest(newConfig);
              } catch (error) {
                return Promise.reject(error);
              }

              while (responseInterceptorChain.length) {
                promise = promise.then(responseInterceptorChain.shift(), responseInterceptorChain.shift());
              }

              return promise;
            };

            Axios$1.prototype.getUri = function getUri(config) {
              config = mergeConfig$1(this.defaults, config);
              return buildURL(config.url, config.params, config.paramsSerializer).replace(/^\?/, '');
            };

            // Provide aliases for supported request methods
            utils$2.forEach(['delete', 'get', 'head', 'options'], function forEachMethodNoData(method) {
              /*eslint func-names:0*/
              Axios$1.prototype[method] = function(url, config) {
                return this.request(mergeConfig$1(config || {}, {
                  method: method,
                  url: url,
                  data: (config || {}).data
                }));
              };
            });

            utils$2.forEach(['post', 'put', 'patch'], function forEachMethodWithData(method) {
              /*eslint func-names:0*/
              Axios$1.prototype[method] = function(url, data, config) {
                return this.request(mergeConfig$1(config || {}, {
                  method: method,
                  url: url,
                  data: data
                }));
              };
            });

            var Axios_1 = Axios$1;

            var Cancel = Cancel_1;

            /**
             * A `CancelToken` is an object that can be used to request cancellation of an operation.
             *
             * @class
             * @param {Function} executor The executor function.
             */
            function CancelToken(executor) {
              if (typeof executor !== 'function') {
                throw new TypeError('executor must be a function.');
              }

              var resolvePromise;

              this.promise = new Promise(function promiseExecutor(resolve) {
                resolvePromise = resolve;
              });

              var token = this;

              // eslint-disable-next-line func-names
              this.promise.then(function(cancel) {
                if (!token._listeners) return;

                var i;
                var l = token._listeners.length;

                for (i = 0; i < l; i++) {
                  token._listeners[i](cancel);
                }
                token._listeners = null;
              });

              // eslint-disable-next-line func-names
              this.promise.then = function(onfulfilled) {
                var _resolve;
                // eslint-disable-next-line func-names
                var promise = new Promise(function(resolve) {
                  token.subscribe(resolve);
                  _resolve = resolve;
                }).then(onfulfilled);

                promise.cancel = function reject() {
                  token.unsubscribe(_resolve);
                };

                return promise;
              };

              executor(function cancel(message) {
                if (token.reason) {
                  // Cancellation has already been requested
                  return;
                }

                token.reason = new Cancel(message);
                resolvePromise(token.reason);
              });
            }

            /**
             * Throws a `Cancel` if cancellation has been requested.
             */
            CancelToken.prototype.throwIfRequested = function throwIfRequested() {
              if (this.reason) {
                throw this.reason;
              }
            };

            /**
             * Subscribe to the cancel signal
             */

            CancelToken.prototype.subscribe = function subscribe(listener) {
              if (this.reason) {
                listener(this.reason);
                return;
              }

              if (this._listeners) {
                this._listeners.push(listener);
              } else {
                this._listeners = [listener];
              }
            };

            /**
             * Unsubscribe from the cancel signal
             */

            CancelToken.prototype.unsubscribe = function unsubscribe(listener) {
              if (!this._listeners) {
                return;
              }
              var index = this._listeners.indexOf(listener);
              if (index !== -1) {
                this._listeners.splice(index, 1);
              }
            };

            /**
             * Returns an object that contains a new `CancelToken` and a function that, when called,
             * cancels the `CancelToken`.
             */
            CancelToken.source = function source() {
              var cancel;
              var token = new CancelToken(function executor(c) {
                cancel = c;
              });
              return {
                token: token,
                cancel: cancel
              };
            };

            var CancelToken_1 = CancelToken;

            /**
             * Syntactic sugar for invoking a function and expanding an array for arguments.
             *
             * Common use case would be to use `Function.prototype.apply`.
             *
             *  ```js
             *  function f(x, y, z) {}
             *  var args = [1, 2, 3];
             *  f.apply(null, args);
             *  ```
             *
             * With `spread` this example can be re-written.
             *
             *  ```js
             *  spread(function(x, y, z) {})([1, 2, 3]);
             *  ```
             *
             * @param {Function} callback
             * @returns {Function}
             */
            var spread = function spread(callback) {
              return function wrap(arr) {
                return callback.apply(null, arr);
              };
            };

            var utils$1 = utils$e;

            /**
             * Determines whether the payload is an error thrown by Axios
             *
             * @param {*} payload The value to test
             * @returns {boolean} True if the payload is an error thrown by Axios, otherwise false
             */
            var isAxiosError = function isAxiosError(payload) {
              return utils$1.isObject(payload) && (payload.isAxiosError === true);
            };

            var utils = utils$e;
            var bind = bind$2;
            var Axios = Axios_1;
            var mergeConfig = mergeConfig$2;
            var defaults = defaults_1;

            /**
             * Create an instance of Axios
             *
             * @param {Object} defaultConfig The default config for the instance
             * @return {Axios} A new instance of Axios
             */
            function createInstance(defaultConfig) {
              var context = new Axios(defaultConfig);
              var instance = bind(Axios.prototype.request, context);

              // Copy axios.prototype to instance
              utils.extend(instance, Axios.prototype, context);

              // Copy context to instance
              utils.extend(instance, context);

              // Factory for creating new instances
              instance.create = function create(instanceConfig) {
                return createInstance(mergeConfig(defaultConfig, instanceConfig));
              };

              return instance;
            }

            // Create the default instance to be exported
            var axios$1 = createInstance(defaults);

            // Expose Axios class to allow class inheritance
            axios$1.Axios = Axios;

            // Expose Cancel & CancelToken
            axios$1.Cancel = Cancel_1;
            axios$1.CancelToken = CancelToken_1;
            axios$1.isCancel = isCancel$1;
            axios$1.VERSION = data.version;

            // Expose all/spread
            axios$1.all = function all(promises) {
              return Promise.all(promises);
            };
            axios$1.spread = spread;

            // Expose isAxiosError
            axios$1.isAxiosError = isAxiosError;

            axios$2.exports = axios$1;

            // Allow use of default import syntax in TypeScript
            axios$2.exports.default = axios$1;

            var axios = axios$2.exports;

            var HttpDebugger = /** @class */ (function () {
                function HttpDebugger() {
                }
                /*
                Called when http request is started
                */
                HttpDebugger.prototype.debugStartHttpRequest = function () {
                };
                /*
                Called when http request is resolved
                */
                HttpDebugger.prototype.debugSuccessHttpRequest = function () {
                };
                /*
                Called when http request is being retried
                */
                HttpDebugger.prototype.debugRetryHttpRequest = function () {
                };
                return HttpDebugger;
            }());
            var httpDebugger = new HttpDebugger();

            function getWithRetryAsync(instance, call, functionsConfig, options) {
                var _a;
                return __awaiter$2(this, void 0, void 0, function () {
                    var retryStrategyOptions;
                    var _this = this;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                retryStrategyOptions = (_a = options === null || options === void 0 ? void 0 : options.retryStrategy) !== null && _a !== void 0 ? _a : retryHelper.defaultRetryStrategy;
                                return [4 /*yield*/, runWithRetryAsync({
                                        retryAttempt: 0,
                                        url: call.url,
                                        retryStrategy: retryStrategyOptions,
                                        functionsConfig: functionsConfig,
                                        call: function (retryAttempt) { return __awaiter$2(_this, void 0, void 0, function () {
                                            var axiosResponse, response;
                                            var _a, _b;
                                            return __generator(this, function (_c) {
                                                switch (_c.label) {
                                                    case 0:
                                                        httpDebugger.debugStartHttpRequest();
                                                        return [4 /*yield*/, instance.get(call.url, {
                                                                headers: getHeadersJson((_a = options === null || options === void 0 ? void 0 : options.headers) !== null && _a !== void 0 ? _a : [], false),
                                                                responseType: options === null || options === void 0 ? void 0 : options.responseType,
                                                                cancelToken: (_b = options === null || options === void 0 ? void 0 : options.cancelToken) === null || _b === void 0 ? void 0 : _b.token
                                                            })];
                                                    case 1:
                                                        axiosResponse = _c.sent();
                                                        response = {
                                                            data: axiosResponse.data,
                                                            rawResponse: axiosResponse,
                                                            headers: extractHeadersFromAxiosResponse(axiosResponse),
                                                            status: axiosResponse.status,
                                                            retryStrategy: {
                                                                options: retryStrategyOptions,
                                                                retryAttempts: retryAttempt
                                                            }
                                                        };
                                                        httpDebugger.debugSuccessHttpRequest();
                                                        return [2 /*return*/, response];
                                                }
                                            });
                                        }); }
                                    })];
                            case 1: return [2 /*return*/, _b.sent()];
                        }
                    });
                });
            }
            function postWithRetryAsync(instance, call, functionsConfig, options) {
                var _a;
                return __awaiter$2(this, void 0, void 0, function () {
                    var retryStrategyOptions;
                    var _this = this;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                retryStrategyOptions = (_a = options === null || options === void 0 ? void 0 : options.retryStrategy) !== null && _a !== void 0 ? _a : retryHelper.defaultRetryStrategy;
                                return [4 /*yield*/, runWithRetryAsync({
                                        retryAttempt: 0,
                                        url: call.url,
                                        retryStrategy: retryStrategyOptions,
                                        functionsConfig: functionsConfig,
                                        call: function (retryAttempt) { return __awaiter$2(_this, void 0, void 0, function () {
                                            var axiosResponse, response;
                                            var _a, _b;
                                            return __generator(this, function (_c) {
                                                switch (_c.label) {
                                                    case 0:
                                                        httpDebugger.debugStartHttpRequest();
                                                        return [4 /*yield*/, instance.post(call.url, call.body, {
                                                                headers: getHeadersJson((_a = options === null || options === void 0 ? void 0 : options.headers) !== null && _a !== void 0 ? _a : [], false),
                                                                responseType: options === null || options === void 0 ? void 0 : options.responseType,
                                                                // required for uploading large files
                                                                // https://github.com/axios/axios/issues/1362
                                                                maxContentLength: 'Infinity',
                                                                maxBodyLength: 'Infinity',
                                                                cancelToken: (_b = options === null || options === void 0 ? void 0 : options.cancelToken) === null || _b === void 0 ? void 0 : _b.token
                                                            })];
                                                    case 1:
                                                        axiosResponse = _c.sent();
                                                        response = {
                                                            data: axiosResponse.data,
                                                            rawResponse: axiosResponse,
                                                            headers: extractHeadersFromAxiosResponse(axiosResponse),
                                                            status: axiosResponse.status,
                                                            retryStrategy: {
                                                                options: retryStrategyOptions,
                                                                retryAttempts: retryAttempt
                                                            }
                                                        };
                                                        httpDebugger.debugSuccessHttpRequest();
                                                        return [2 /*return*/, response];
                                                }
                                            });
                                        }); }
                                    })];
                            case 1: return [2 /*return*/, _b.sent()];
                        }
                    });
                });
            }
            function putWithRetryAsync(instance, call, functionsConfig, options) {
                var _a;
                return __awaiter$2(this, void 0, void 0, function () {
                    var retryStrategyOptions;
                    var _this = this;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                retryStrategyOptions = (_a = options === null || options === void 0 ? void 0 : options.retryStrategy) !== null && _a !== void 0 ? _a : retryHelper.defaultRetryStrategy;
                                return [4 /*yield*/, runWithRetryAsync({
                                        retryAttempt: 0,
                                        url: call.url,
                                        retryStrategy: retryStrategyOptions,
                                        functionsConfig: functionsConfig,
                                        call: function (retryAttempt) { return __awaiter$2(_this, void 0, void 0, function () {
                                            var axiosResponse, response;
                                            var _a, _b;
                                            return __generator(this, function (_c) {
                                                switch (_c.label) {
                                                    case 0:
                                                        httpDebugger.debugStartHttpRequest();
                                                        return [4 /*yield*/, instance.put(call.url, call.body, {
                                                                headers: getHeadersJson((_a = options === null || options === void 0 ? void 0 : options.headers) !== null && _a !== void 0 ? _a : [], false),
                                                                responseType: options === null || options === void 0 ? void 0 : options.responseType,
                                                                // required for uploading large files
                                                                // https://github.com/axios/axios/issues/1362
                                                                maxContentLength: 'Infinity',
                                                                maxBodyLength: 'Infinity',
                                                                cancelToken: (_b = options === null || options === void 0 ? void 0 : options.cancelToken) === null || _b === void 0 ? void 0 : _b.token
                                                            })];
                                                    case 1:
                                                        axiosResponse = _c.sent();
                                                        response = {
                                                            data: axiosResponse.data,
                                                            rawResponse: axiosResponse,
                                                            headers: extractHeadersFromAxiosResponse(axiosResponse),
                                                            status: axiosResponse.status,
                                                            retryStrategy: {
                                                                options: retryStrategyOptions,
                                                                retryAttempts: retryAttempt
                                                            }
                                                        };
                                                        httpDebugger.debugSuccessHttpRequest();
                                                        return [2 /*return*/, response];
                                                }
                                            });
                                        }); }
                                    })];
                            case 1: return [2 /*return*/, _b.sent()];
                        }
                    });
                });
            }
            function patchWithRetryAsync(instance, call, functionsConfig, options) {
                var _a;
                return __awaiter$2(this, void 0, void 0, function () {
                    var retryStrategyOptions;
                    var _this = this;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                retryStrategyOptions = (_a = options === null || options === void 0 ? void 0 : options.retryStrategy) !== null && _a !== void 0 ? _a : retryHelper.defaultRetryStrategy;
                                return [4 /*yield*/, runWithRetryAsync({
                                        retryAttempt: 0,
                                        url: call.url,
                                        retryStrategy: retryStrategyOptions,
                                        functionsConfig: functionsConfig,
                                        call: function (retryAttempt) { return __awaiter$2(_this, void 0, void 0, function () {
                                            var axiosResponse, response;
                                            var _a, _b;
                                            return __generator(this, function (_c) {
                                                switch (_c.label) {
                                                    case 0:
                                                        httpDebugger.debugStartHttpRequest();
                                                        return [4 /*yield*/, instance.patch(call.url, call.body, {
                                                                headers: getHeadersJson((_a = options === null || options === void 0 ? void 0 : options.headers) !== null && _a !== void 0 ? _a : [], false),
                                                                responseType: options === null || options === void 0 ? void 0 : options.responseType,
                                                                // required for uploading large files
                                                                // https://github.com/axios/axios/issues/1362
                                                                maxContentLength: 'Infinity',
                                                                maxBodyLength: 'Infinity',
                                                                cancelToken: (_b = options === null || options === void 0 ? void 0 : options.cancelToken) === null || _b === void 0 ? void 0 : _b.token
                                                            })];
                                                    case 1:
                                                        axiosResponse = _c.sent();
                                                        response = {
                                                            data: axiosResponse.data,
                                                            rawResponse: axiosResponse,
                                                            headers: extractHeadersFromAxiosResponse(axiosResponse),
                                                            status: axiosResponse.status,
                                                            retryStrategy: {
                                                                options: retryStrategyOptions,
                                                                retryAttempts: retryAttempt
                                                            }
                                                        };
                                                        httpDebugger.debugSuccessHttpRequest();
                                                        return [2 /*return*/, response];
                                                }
                                            });
                                        }); }
                                    })];
                            case 1: return [2 /*return*/, _b.sent()];
                        }
                    });
                });
            }
            function deletehWithRetryAsync(instance, call, functionsConfig, options) {
                var _a;
                return __awaiter$2(this, void 0, void 0, function () {
                    var retryStrategyOptions;
                    var _this = this;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                retryStrategyOptions = (_a = options === null || options === void 0 ? void 0 : options.retryStrategy) !== null && _a !== void 0 ? _a : retryHelper.defaultRetryStrategy;
                                return [4 /*yield*/, runWithRetryAsync({
                                        retryAttempt: 0,
                                        url: call.url,
                                        retryStrategy: retryStrategyOptions,
                                        functionsConfig: functionsConfig,
                                        call: function (retryAttempt) { return __awaiter$2(_this, void 0, void 0, function () {
                                            var axiosResponse, response;
                                            var _a, _b;
                                            return __generator(this, function (_c) {
                                                switch (_c.label) {
                                                    case 0:
                                                        httpDebugger.debugStartHttpRequest();
                                                        return [4 /*yield*/, instance.delete(call.url, {
                                                                headers: getHeadersJson((_a = options === null || options === void 0 ? void 0 : options.headers) !== null && _a !== void 0 ? _a : [], false),
                                                                responseType: options === null || options === void 0 ? void 0 : options.responseType,
                                                                // required for uploading large files
                                                                // https://github.com/axios/axios/issues/1362
                                                                maxContentLength: 'Infinity',
                                                                maxBodyLength: 'Infinity',
                                                                cancelToken: (_b = options === null || options === void 0 ? void 0 : options.cancelToken) === null || _b === void 0 ? void 0 : _b.token
                                                            })];
                                                    case 1:
                                                        axiosResponse = _c.sent();
                                                        response = {
                                                            data: axiosResponse.data,
                                                            rawResponse: axiosResponse,
                                                            headers: extractHeadersFromAxiosResponse(axiosResponse),
                                                            status: axiosResponse.status,
                                                            retryStrategy: {
                                                                options: retryStrategyOptions,
                                                                retryAttempts: retryAttempt
                                                            }
                                                        };
                                                        httpDebugger.debugSuccessHttpRequest();
                                                        return [2 /*return*/, response];
                                                }
                                            });
                                        }); }
                                    })];
                            case 1: return [2 /*return*/, _b.sent()];
                        }
                    });
                });
            }
            function createCancelToken() {
                var canceler;
                var token = new axios.CancelToken(function (c) {
                    // An executor function receives a cancel function as a parameter
                    canceler = c;
                });
                return {
                    cancel: function (cancelMessage) {
                        return canceler("".concat(retryHelper.requestCancelledMessagePrefix, ": ").concat(cancelMessage !== null && cancelMessage !== void 0 ? cancelMessage : 'User cancel'));
                    },
                    token: token
                };
            }
            function runWithRetryAsync(data) {
                return __awaiter$2(this, void 0, void 0, function () {
                    var error_1, retryResult_1;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                _a.trys.push([0, 2, , 6]);
                                return [4 /*yield*/, data.call(data.retryAttempt)];
                            case 1: return [2 /*return*/, _a.sent()];
                            case 2:
                                error_1 = _a.sent();
                                retryResult_1 = retryHelper.getRetryErrorResult({
                                    error: error_1,
                                    retryAttempt: data.retryAttempt,
                                    retryStrategy: data.retryStrategy
                                });
                                if (!retryResult_1.canRetry) return [3 /*break*/, 5];
                                httpDebugger.debugRetryHttpRequest();
                                // wait time before retrying
                                return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, retryResult_1.retryInMs); })];
                            case 3:
                                // wait time before retrying
                                _a.sent();
                                // retry request
                                console.warn("Retry attempt '".concat(data.retryAttempt + 1, "' from a maximum of '").concat(retryResult_1.maxRetries, "' retries. Request url: '").concat(data.url, "'"));
                                return [4 /*yield*/, runWithRetryAsync({
                                        call: data.call,
                                        retryStrategy: data.retryStrategy,
                                        retryAttempt: data.retryAttempt + 1,
                                        url: data.url,
                                        functionsConfig: data.functionsConfig
                                    })];
                            case 4: return [2 /*return*/, _a.sent()];
                            case 5:
                                if (data.functionsConfig.logErrorsToConsole) {
                                    console.error("Executing '".concat(data.url, "' failed. Request was retried '").concat(data.retryAttempt, "' times. "), error_1);
                                }
                                throw error_1;
                            case 6: return [2 /*return*/];
                        }
                    });
                });
            }
            function getHeadersJson(headers, addContentTypeHeader) {
                var headerJson = {};
                headers.forEach(function (header) {
                    headerJson[header.header] = header.value;
                });
                if (addContentTypeHeader) {
                    // add default content type header if not present
                    var contentTypeHeader = headers.find(function (m) { return m.header.toLowerCase() === 'Content-Type'.toLowerCase(); });
                    if (!contentTypeHeader) {
                        headerJson['Content-Type'] = 'application/json';
                    }
                }
                return headerJson;
            }

            var HttpService = /** @class */ (function () {
                function HttpService(opts) {
                    this.opts = opts;
                    this.axiosInstance = axios.create(opts === null || opts === void 0 ? void 0 : opts.axiosRequestConfig);
                    this.functionsConfig = this.getFunctionsConfig();
                }
                HttpService.prototype.getAsync = function (call, options) {
                    return __awaiter$2(this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, getWithRetryAsync(this.axiosInstance, call, this.functionsConfig, options)];
                                case 1: return [2 /*return*/, _a.sent()];
                            }
                        });
                    });
                };
                HttpService.prototype.postAsync = function (call, options) {
                    return __awaiter$2(this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, postWithRetryAsync(this.axiosInstance, call, this.functionsConfig, options)];
                                case 1: return [2 /*return*/, _a.sent()];
                            }
                        });
                    });
                };
                HttpService.prototype.putAsync = function (call, options) {
                    return __awaiter$2(this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, putWithRetryAsync(this.axiosInstance, call, this.functionsConfig, options)];
                                case 1: return [2 /*return*/, _a.sent()];
                            }
                        });
                    });
                };
                HttpService.prototype.patchAsync = function (call, options) {
                    return __awaiter$2(this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, patchWithRetryAsync(this.axiosInstance, call, this.functionsConfig, options)];
                                case 1: return [2 /*return*/, _a.sent()];
                            }
                        });
                    });
                };
                HttpService.prototype.deleteAsync = function (call, options) {
                    return __awaiter$2(this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, deletehWithRetryAsync(this.axiosInstance, call, this.functionsConfig, options)];
                                case 1: return [2 /*return*/, _a.sent()];
                            }
                        });
                    });
                };
                HttpService.prototype.createCancelToken = function () {
                    return createCancelToken();
                };
                HttpService.prototype.getFunctionsConfig = function () {
                    var _a, _b;
                    return {
                        logErrorsToConsole: (_b = (_a = this.opts) === null || _a === void 0 ? void 0 : _a.logErrorsToConsole) !== null && _b !== void 0 ? _b : true
                    };
                };
                return HttpService;
            }());

            var Filters;
            (function (Filters) {
                const valueSeparator = ',';
                const defaultValue = '';
                const getParamValueForSystemFilter = (param) => {
                    if (!param) {
                        return defaultValue;
                    }
                    if (Array.isArray(param)) {
                        let value = '';
                        // use [in] filter
                        for (let i = 0; i < param.length; i++) {
                            value = value + param[i].toString();
                            if (i !== param.length - 1) {
                                // append separator if its not last item
                                value = value + valueSeparator;
                            }
                        }
                        return value;
                    }
                    // single param was given
                    return param.toString();
                };
                class TypeFilter {
                    constructor(type) {
                        this.type = type;
                    }
                    getParam() {
                        if (Array.isArray(this.type)) {
                            // multiple types
                            return `system.type[in]=${getParamValueForSystemFilter(this.type)}`;
                        }
                        // single type
                        return `system.type=${getParamValueForSystemFilter(this.type)}`;
                    }
                }
                Filters.TypeFilter = TypeFilter;
                class CollectionFilter {
                    constructor(collection) {
                        this.collection = collection;
                    }
                    getParam() {
                        if (Array.isArray(this.collection)) {
                            // multiple collections
                            return `system.collection[in]=${getParamValueForSystemFilter(this.collection)}`;
                        }
                        // single collection
                        return `system.collection=${getParamValueForSystemFilter(this.collection)}`;
                    }
                }
                Filters.CollectionFilter = CollectionFilter;
                class EmptyFilter {
                    constructor(element) {
                        this.element = element;
                    }
                    getParam() {
                        return `${this.element.trim()}[empty]`;
                    }
                }
                Filters.EmptyFilter = EmptyFilter;
                class NotEmptyFilter {
                    constructor(element) {
                        this.element = element;
                    }
                    getParam() {
                        return `${this.element.trim()}[nempty]`;
                    }
                }
                Filters.NotEmptyFilter = NotEmptyFilter;
                class EqualsFilter {
                    constructor(element, value) {
                        this.element = element;
                        this.value = value;
                    }
                    getParam() {
                        return `${this.element.trim()}[eq]=${this.getParamValue()}`;
                    }
                    getParamValue() {
                        if (!this.value) {
                            return defaultValue;
                        }
                        return this.value;
                    }
                }
                Filters.EqualsFilter = EqualsFilter;
                class NotEqualsFilter {
                    constructor(element, value) {
                        this.element = element;
                        this.value = value;
                    }
                    getParam() {
                        return `${this.element.trim()}[neq]=${this.getParamValue()}`;
                    }
                    getParamValue() {
                        if (!this.value) {
                            return defaultValue;
                        }
                        return this.value;
                    }
                }
                Filters.NotEqualsFilter = NotEqualsFilter;
                class AllFilter {
                    constructor(element, values) {
                        this.element = element;
                        this.values = values;
                    }
                    getParam() {
                        return `${this.element.trim()}[all]=${this.getParamValue()}`;
                    }
                    getParamValue() {
                        if (!this.values || !Array.isArray(this.values)) {
                            return defaultValue;
                        }
                        return this.values.map((m) => m.trim()).join(',');
                    }
                }
                Filters.AllFilter = AllFilter;
                class AnyFilter {
                    constructor(element, values) {
                        this.element = element;
                        this.values = values;
                    }
                    getParam() {
                        return `${this.element.trim()}[any]=${this.getParamValue()}`;
                    }
                    getParamValue() {
                        if (!this.values || !Array.isArray(this.values)) {
                            return defaultValue;
                        }
                        return this.values.map((m) => m.trim()).join(',');
                    }
                }
                Filters.AnyFilter = AnyFilter;
                class ContainsFilter {
                    constructor(element, values) {
                        this.element = element;
                        this.values = values;
                    }
                    getParam() {
                        return `${this.element.trim()}[contains]=${this.getParamValue()}`;
                    }
                    getParamValue() {
                        if (!this.values || !Array.isArray(this.values)) {
                            return defaultValue;
                        }
                        return this.values.map((m) => m.trim()).join(',');
                    }
                }
                Filters.ContainsFilter = ContainsFilter;
                class GreaterThanFilter {
                    constructor(element, value) {
                        this.element = element;
                        this.value = value;
                    }
                    getParam() {
                        return `${this.element.trim()}[gt]=${this.getParamValue()}`;
                    }
                    getParamValue() {
                        if (!this.value) {
                            return defaultValue;
                        }
                        return this.value;
                    }
                }
                Filters.GreaterThanFilter = GreaterThanFilter;
                class GreaterThanOrEqualFilter {
                    constructor(element, value) {
                        this.element = element;
                        this.value = value;
                    }
                    getParam() {
                        return `${this.element.trim()}[gte]=${this.getParamValue()}`;
                    }
                    getParamValue() {
                        if (!this.value) {
                            return defaultValue;
                        }
                        return this.value;
                    }
                }
                Filters.GreaterThanOrEqualFilter = GreaterThanOrEqualFilter;
                class InFilter {
                    constructor(element, values) {
                        this.element = element;
                        this.values = values;
                    }
                    getParam() {
                        return `${this.element.trim()}[in]=${this.getParamValue()}`;
                    }
                    getParamValue() {
                        if (!this.values || !Array.isArray(this.values)) {
                            return defaultValue;
                        }
                        return this.values
                            .map((m) => {
                            return m.trim();
                        })
                            .join(',');
                    }
                }
                Filters.InFilter = InFilter;
                class NotInFilter {
                    constructor(element, values) {
                        this.element = element;
                        this.values = values;
                    }
                    getParam() {
                        return `${this.element.trim()}[nin]=${this.getParamValue()}`;
                    }
                    getParamValue() {
                        if (!this.values || !Array.isArray(this.values)) {
                            return defaultValue;
                        }
                        return this.values
                            .map((m) => {
                            return m.trim();
                        })
                            .join(',');
                    }
                }
                Filters.NotInFilter = NotInFilter;
                class LessThanFilter {
                    constructor(element, value) {
                        this.element = element;
                        this.value = value;
                    }
                    getParam() {
                        return `${this.element.trim()}[lt]=${this.getParamValue()}`;
                    }
                    getParamValue() {
                        if (!this.value) {
                            return defaultValue;
                        }
                        return this.value;
                    }
                }
                Filters.LessThanFilter = LessThanFilter;
                class LessThanOrEqualFilter {
                    constructor(element, value) {
                        this.element = element;
                        this.value = value;
                    }
                    getParam() {
                        return `${this.element.trim()}[lte]=${this.getParamValue()}`;
                    }
                    getParamValue() {
                        if (!this.value) {
                            return defaultValue;
                        }
                        return this.value;
                    }
                }
                Filters.LessThanOrEqualFilter = LessThanOrEqualFilter;
                class RangeFilter {
                    constructor(element, lowerValue, higherValue) {
                        this.element = element;
                        this.lowerValue = lowerValue;
                        this.higherValue = higherValue;
                    }
                    getParam() {
                        return `${this.element.trim()}[range]=${this.getParamValue()}`;
                    }
                    getParamValue() {
                        let lowerVal = defaultValue;
                        let higherVal = defaultValue;
                        if (this.lowerValue) {
                            lowerVal = this.lowerValue.toString();
                        }
                        if (this.higherValue) {
                            higherVal = this.higherValue.toString();
                        }
                        return `${lowerVal},${higherVal}`;
                    }
                }
                Filters.RangeFilter = RangeFilter;
            })(Filters || (Filters = {}));

            var Parameters;
            (function (Parameters) {
                const defaultValue = '';
                class QueryParameter {
                    /**
                     * Parameter
                     * @constructor
                     * @param {string} name - Name of the parameter
                     * @param {string} value - Value of the parameter
                     */
                    constructor(name, value) {
                        this.name = name;
                        this.value = value;
                        if (!name) {
                            throw Error(`Name of the parameter is not specified`);
                        }
                    }
                    getParam() {
                        return `${this.name}=${this.value}`;
                    }
                }
                Parameters.QueryParameter = QueryParameter;
                class ElementsParameter {
                    /**
                     * Sets elements (projection) so that only certain elements from a content item are returned
                     * @constructor
                     * @param {string[]} elementCodenames - Array of element codenames to include in response.
                     */
                    constructor(elementCodenames) {
                        this.elementCodenames = elementCodenames;
                    }
                    getParam() {
                        return `elements=${this.getParamValue()}`;
                    }
                    getParamValue() {
                        if (!this.elementCodenames) {
                            return defaultValue;
                        }
                        return this.elementCodenames
                            .map((m) => {
                            if (!m) {
                                throw Error(`Codename of 'ElementsParameter' cannot be null or empty`);
                            }
                            return m.trim();
                        })
                            .join(',');
                    }
                }
                Parameters.ElementsParameter = ElementsParameter;
                class LimitParameter {
                    /**
                     * Limits the number of items that are returned from response
                     * @constructor
                     * @param {number} limit - Number of elements that will be returned
                     */
                    constructor(limit) {
                        this.limit = limit;
                        if (limit <= 0) {
                            throw Error(`'LimitParameter' must specify a positive integer`);
                        }
                    }
                    getParam() {
                        return `limit=${this.limit}`;
                    }
                }
                Parameters.LimitParameter = LimitParameter;
                class IncludeTotalCountParameter {
                    /**
                     * Adds 'includeTotalCount' query parameter to query
                     * @constructor
                     */
                    constructor() { }
                    getParam() {
                        return `includeTotalCount=true`;
                    }
                }
                Parameters.IncludeTotalCountParameter = IncludeTotalCountParameter;
                class SkipParameter {
                    /**
                     * Configures response to skip certain number of items
                     * @constructor
                     * @param {number} skip - Number of content items that will be skipped
                     */
                    constructor(skip) {
                        this.skip = skip;
                        if (skip < 0) {
                            throw Error(`'SkipParameter' must specify a positive integer number or zero."`);
                        }
                    }
                    getParam() {
                        return `skip=${this.skip}`;
                    }
                }
                Parameters.SkipParameter = SkipParameter;
                class OrderParameter {
                    /**
                     * Sorts the response based on given element.
                     * @constructor
                     * @param {string} element - Element that will be used for sorting (can be both elements.<elementname> or system.<elementname>)
                     * @param {SortOrder} sortOrder - Order type (desc/asc). Defaults to 'asc' if SortOrder is null or invalid.
                     */
                    constructor(element, sortOrder) {
                        this.element = element;
                        this.sortOrder = sortOrder;
                        if (!element) {
                            throw Error(`Element specified in 'OrderParameter' is null or empty`);
                        }
                    }
                    getParam() {
                        return `order=${this.getParamValue()}`;
                    }
                    getParamValue() {
                        return `${this.element.trim()}[${this.sortOrder}]`;
                    }
                }
                Parameters.OrderParameter = OrderParameter;
                class CustomParameter {
                    constructor(param) {
                        this.param = param;
                    }
                    getParam() {
                        return this.param;
                    }
                }
                Parameters.CustomParameter = CustomParameter;
                class DepthParameter {
                    /**
                     * Configures the depth of the response. Content items might reference another 'linked items' using the Linked items element.
                     * Recursively, these linked items can reference another linked items.
                     * By default, only one level of linked content is returned.
                     * @constructor
                     * @param {number} depth - Depth fo the response
                     */
                    constructor(depth) {
                        this.depth = depth;
                        if (depth < 0) {
                            throw Error(`'DepthParameter' must specify a positive integer or zero`);
                        }
                    }
                    getParam() {
                        return `depth=${this.depth}`;
                    }
                }
                Parameters.DepthParameter = DepthParameter;
                class LanguageParameter {
                    /**
                     * Specifies language version to fetch
                     * @constructor
                     * @param {string} languageCodename - Codename of the language
                     */
                    constructor(languageCodename) {
                        this.languageCodename = languageCodename;
                        if (!languageCodename) {
                            throw Error(`'LanguageParameter' must specify codename of the language`);
                        }
                    }
                    getParam() {
                        return `language=${this.languageCodename}`;
                    }
                }
                Parameters.LanguageParameter = LanguageParameter;
            })(Parameters || (Parameters = {}));

            class DeliveryError {
                constructor(data) {
                    this.message = data.message;
                    this.requestId = data.requestId;
                    this.errorCode = data.errorCode;
                    this.specificCode = data.specificCode;
                }
            }

            const continuationTokenHeaderName = 'X-Continuation';
            const waitForLoadingNewContentHeader = 'X-KC-Wait-For-Loading-New-Content';
            const sdkVersionHeader = 'X-KC-SDKID';
            const staleContentHeaderName = 'X-Stale-Content';

            class BaseQuery {
                constructor(config, queryService) {
                    this.config = config;
                    this.queryService = queryService;
                    this.parameters = [];
                    this.headers = [];
                }
                /**
                 * Adds custom parameter to query
                 * @param name Name of parameter
                 * @param value Value of parameter
                 */
                withCustomParameter(name, value) {
                    this.parameters.push(new Parameters.QueryParameter(name, value));
                    return this;
                }
                /**
                 * Adds parameter to query
                 * @param name Name of parameter
                 * @param value Value of parameter
                 */
                withParameter(parameter) {
                    this.parameters.push(parameter);
                    return this;
                }
                /**
                 * Adds parameters to query
                 * @param parameters Array of parameters
                 */
                withParameters(parameters) {
                    this.parameters.push(...parameters);
                    return this;
                }
                /**
                 * Gets headers used by this query
                 */
                getHeaders() {
                    var _a;
                    return this.queryService.getHeaders((_a = this._queryConfig) !== null && _a !== void 0 ? _a : {}, this.headers);
                }
                /**
                 * Sets request headers
                 */
                withHeaders(headers) {
                    this.headers.push(...headers);
                    return this;
                }
                /**
                 * Sets request header
                 */
                withHeader(header) {
                    this.headers.push(header);
                    return this;
                }
                /**
                 * Sets custom URL of request (overrides default URL of the query)
                 */
                withCustomUrl(url) {
                    this.customUrl = url;
                    return this;
                }
                /**
                 * Gets all query parameter currently applied to query
                 */
                getParameters() {
                    return this.parameters;
                }
                /**
                 * Used to configure query
                 * @param queryConfig Query configuration
                 */
                queryConfig(queryConfig) {
                    this._queryConfig = queryConfig;
                    return this;
                }
                resolveUrlInternal(action) {
                    var _a;
                    // use custom URL if user specified it
                    if (this.customUrl) {
                        return this.customUrl;
                    }
                    // use original url
                    return this.queryService.getUrl(action, (_a = this._queryConfig) !== null && _a !== void 0 ? _a : {}, this.getParameters());
                }
                processDefaultLanguageParameter() {
                    // add default language if none is specified && default language is specified globally
                    if (this.config.defaultLanguage) {
                        const languageParameter = this.getParameters().find((m) => m.getParam() === 'language');
                        if (!languageParameter) {
                            // language parameter was not specified in query, use globally defined language
                            this.parameters.push(new Parameters.LanguageParameter(this.config.defaultLanguage));
                        }
                    }
                }
            }

            class ElementQuery extends BaseQuery {
                constructor(config, queryService, typeCodename, elementCodename) {
                    super(config, queryService);
                    this.config = config;
                    this.queryService = queryService;
                    this.typeCodename = typeCodename;
                    this.elementCodename = elementCodename;
                    if (!typeCodename) {
                        throw Error(`Codename of the type has to be provided`);
                    }
                    if (!elementCodename) {
                        throw Error(`Codename of the element has to be provided`);
                    }
                }
                toPromise() {
                    var _a;
                    return this.queryService.getElementAsync(this.getUrl(), (_a = this._queryConfig) !== null && _a !== void 0 ? _a : {});
                }
                getUrl() {
                    const action = '/types/' + this.typeCodename + '/elements/' + this.elementCodename;
                    return super.resolveUrlInternal(action);
                }
                map(json) {
                    return this.queryService.mappingService.viewContentTypeElementResponse(json);
                }
            }

            class BaseListingQuery extends BaseQuery {
                constructor(config, queryService) {
                    super(config, queryService);
                    this.config = config;
                    this.queryService = queryService;
                }
                /**
                 * Empty filter condition
                 * @param element Element with empty value
                 */
                emptyFilter(element) {
                    this.parameters.push(new Filters.EmptyFilter(element));
                    return this;
                }
                /**
                 * Not empty filter condition
                 * @param element Element with non-empty value
                 */
                notEmptyFilter(element) {
                    this.parameters.push(new Filters.NotEmptyFilter(element));
                    return this;
                }
                /**
                 * Equals filter condition
                 * @param element Element to filter. Example: 'elements.movie'
                 * @param value Value to match. Example: 'Kingsman'
                 */
                equalsFilter(element, value) {
                    this.parameters.push(new Filters.EqualsFilter(element, value));
                    return this;
                }
                /**
                 * Not equals filter condition
                 * @param element Element to filter. Example: 'elements.movie'
                 * @param value Value to match. Example: 'Kingsman'
                 */
                notEqualsFilter(element, value) {
                    this.parameters.push(new Filters.NotEqualsFilter(element, value));
                    return this;
                }
                /**
                 * All filter
                 * @param element Element to filter.
                 * @param values Values
                 */
                allFilter(element, values) {
                    this.parameters.push(new Filters.AllFilter(element, values));
                    return this;
                }
                /**
                 * Any filter
                 * @param element Element to filter.
                 * @param values Values
                 */
                anyFilter(element, values) {
                    this.parameters.push(new Filters.AnyFilter(element, values));
                    return this;
                }
                /**
                 * Contains filter
                 * @param element Element to filter.
                 * @param values Values
                 */
                containsFilter(element, values) {
                    this.parameters.push(new Filters.ContainsFilter(element, values));
                    return this;
                }
                /**
                 * Greater then filter
                 * @param element Element to filter.
                 * @param value Value
                 */
                greaterThanFilter(element, value) {
                    this.parameters.push(new Filters.GreaterThanFilter(element, value));
                    return this;
                }
                /**
                 * Greater then or equals filter
                 * @param element Element to filter.
                 * @param value Value
                 */
                greaterThanOrEqualFilter(element, value) {
                    this.parameters.push(new Filters.GreaterThanOrEqualFilter(element, value));
                    return this;
                }
                /**
                 * In filter
                 * @param element Element to filter.
                 * @param values Values
                 */
                inFilter(element, values) {
                    this.parameters.push(new Filters.InFilter(element, values));
                    return this;
                }
                /**
                 * Not in filter
                 * @param element Element to filter.
                 * @param values Values
                 */
                notInFilter(element, values) {
                    this.parameters.push(new Filters.NotInFilter(element, values));
                    return this;
                }
                /**
                 * Less then filter
                 * @param element Element to filter.
                 * @param value Value
                 */
                lessThanFilter(element, value) {
                    this.parameters.push(new Filters.LessThanFilter(element, value));
                    return this;
                }
                /**
                 * @param element Element to filter.
                 * @param value Value
                 */
                lessThanOrEqualFilter(element, value) {
                    this.parameters.push(new Filters.LessThanOrEqualFilter(element, value));
                    return this;
                }
                /**
                 * @param element Element to filter.
                 * @param lowerValue Lower value of range (e.g. 2)
                 * @param higherValue Higher value of range (e.g. 10)
                 */
                rangeFilter(element, lowerValue, higherValue) {
                    this.parameters.push(new Filters.RangeFilter(element, lowerValue, higherValue));
                    return this;
                }
                /**
                 * Limits the number of items returned by query
                 * @param limit Number of items to load
                 */
                limitParameter(limit) {
                    this.parameters.push(new Parameters.LimitParameter(limit));
                    return this;
                }
                /**
                 * Orders query based on given element and sort order
                 * @param element Element by which to order
                 * @param sortOrder Asc/Desc order type
                 */
                orderParameter(element, sortOrder) {
                    this.parameters.push(new Parameters.OrderParameter(element, sortOrder));
                    return this;
                }
                /**
                 * Sets descending order on given element
                 * @param element Element by which to order
                 */
                orderByDescending(element) {
                    this.parameters.push(new Parameters.OrderParameter(element, 'desc'));
                    return this;
                }
                /**
                 * Sets Ascending order on given element
                 * @param element Element by which to order
                 */
                orderByAscending(element) {
                    this.parameters.push(new Parameters.OrderParameter(element, 'asc'));
                    return this;
                }
                /**
                 * Skips the selected number of items
                 * @param skip Number of items to skip
                 */
                skipParameter(skip) {
                    this.parameters.push(new Parameters.SkipParameter(skip));
                    return this;
                }
                /**
                 * Sets continuation token header
                 */
                withContinuationToken(token) {
                    this.withHeaders([
                        {
                            header: continuationTokenHeaderName,
                            value: token
                        }
                    ]);
                    return this;
                }
                /**
                 * Query to get all items. Uses paging data and may execute multiple HTTP requests depending on number of items
                 */
                toAllPromise(queryAllConfig) {
                    return this.queryService.getListAllResponse({
                        page: 1,
                        listQueryConfig: queryAllConfig,
                        allResponseFactory: (items, responses) => {
                            const response = this.allResponseFactory(items, responses);
                            return {
                                data: response,
                                responses: responses
                            };
                        },
                        getResponse: (nextPageUrl, continuationToken) => {
                            if (nextPageUrl) {
                                this.withCustomUrl(nextPageUrl).toPromise();
                            }
                            if (continuationToken) {
                                this.withContinuationToken(continuationToken);
                            }
                            return this.toPromise();
                        }
                    });
                }
            }

            class MultipleItemsQuery extends BaseListingQuery {
                constructor(config, queryService) {
                    super(config, queryService);
                    this.config = config;
                    this.queryService = queryService;
                }
                /**
                 * Adds information about the total number of content items matching your query.
                 * When set to true, the pagination object returned in the API response contains
                 * an additional total_count property.
                 */
                includeTotalCountParameter() {
                    this.parameters.push(new Parameters.IncludeTotalCountParameter());
                    return this;
                }
                /**
                 * Gets only item of given type
                 * @param type Codename of type to get
                 */
                type(type) {
                    this.parameters.push(new Filters.TypeFilter(type));
                    return this;
                }
                /**
                 * Gets items of given types (logical or)
                 * I.e. get items of either 'Actor' or 'Movie' type
                 * @param types Types to get
                 */
                types(types) {
                    this.parameters.push(new Filters.TypeFilter(types));
                    return this;
                }
                /**
                 * Gets only item from given collection
                 * @param collection Codename of collection to get
                 */
                collection(collection) {
                    this.parameters.push(new Filters.CollectionFilter(collection));
                    return this;
                }
                /**
                 * Gets items from given collections (logical or)
                 * I.e. get items of either 'default' or 'christmas-campaign' collection
                 * @param collections Collections to get
                 */
                collections(collections) {
                    this.parameters.push(new Filters.CollectionFilter(collections));
                    return this;
                }
                /**
                 * Indicates depth of query that affects loading of nested linked items.
                 * @param depth Depth of the query (> 0)
                 */
                depthParameter(depth) {
                    this.parameters.push(new Parameters.DepthParameter(depth));
                    return this;
                }
                /**
                 * Language codename
                 * @param languageCodename Codename of the language
                 */
                languageParameter(languageCodename) {
                    this.parameters.push(new Parameters.LanguageParameter(languageCodename));
                    return this;
                }
                /**
                 * Used to limit the number of elements returned by query.
                 * @param elementCodenames Array of element codenames to fetch
                 */
                elementsParameter(elementCodenames) {
                    this.parameters.push(new Parameters.ElementsParameter(elementCodenames));
                    return this;
                }
                toPromise() {
                    var _a;
                    return this.queryService.getMultipleItems(this.getUrl(), (_a = this._queryConfig) !== null && _a !== void 0 ? _a : {});
                }
                getUrl() {
                    const action = '/items';
                    // add default language is necessry
                    this.processDefaultLanguageParameter();
                    return super.resolveUrlInternal(action);
                }
                map(json) {
                    return this.queryService.mappingService.listContentItemsResponse(json);
                }
                allResponseFactory(items, responses) {
                    return {
                        items: items,
                        responses: responses
                    };
                }
            }

            class SingleItemQuery extends BaseQuery {
                constructor(config, queryService, codename) {
                    super(config, queryService);
                    this.config = config;
                    this.queryService = queryService;
                    this.codename = codename;
                    if (!codename) {
                        throw Error(`'codename' has to be configured for 'SingleItemQuery' query`);
                    }
                }
                /**
                 * Indicates depth of query that affects loading of nested linked items.
                 * @param depth Depth of the query (> 0)
                 */
                depthParameter(depth) {
                    this.parameters.push(new Parameters.DepthParameter(depth));
                    return this;
                }
                /**
                 * Used to configure query
                 * @param queryConfig Query configuration
                 */
                queryConfig(queryConfig) {
                    this._queryConfig = queryConfig;
                    return this;
                }
                /**
                 * Language codename
                 * @param languageCodename Codename of the language
                 */
                languageParameter(languageCodename) {
                    this.parameters.push(new Parameters.LanguageParameter(languageCodename));
                    return this;
                }
                /**
                 * Used to limit the number of elements returned by query.
                 * @param elementCodenames Array of element codenames to fetch
                 */
                elementsParameter(elementCodenames) {
                    this.parameters.push(new Parameters.ElementsParameter(elementCodenames));
                    return this;
                }
                toPromise() {
                    var _a;
                    return this.queryService.getSingleItemAsync(this.getUrl(), (_a = this._queryConfig) !== null && _a !== void 0 ? _a : {});
                }
                getUrl() {
                    const action = '/items/' + this.codename;
                    // add default language is necessry
                    this.processDefaultLanguageParameter();
                    return super.resolveUrlInternal(action);
                }
                map(json) {
                    return this.queryService.mappingService.viewContentItemResponse(json);
                }
            }

            class TaxonomiesQuery extends BaseListingQuery {
                constructor(config, queryService) {
                    super(config, queryService);
                    this.config = config;
                    this.queryService = queryService;
                    /**
                     * Taxonomies endpoint URL action
                     */
                    this.taxonomiesEndpoint = 'taxonomies';
                }
                /**
                 * Limits the number of taxonomies returned by query
                 * @param limit Number of taxonomies to load
                 */
                limitParameter(limit) {
                    this.parameters.push(new Parameters.LimitParameter(limit));
                    return this;
                }
                /**
                 * Skips the selected number of taxonomies
                 * @param skip Number of taxonomies to skip
                 */
                skipParameter(skip) {
                    this.parameters.push(new Parameters.SkipParameter(skip));
                    return this;
                }
                toPromise() {
                    var _a;
                    return this.queryService.getTaxonomies(this.getUrl(), (_a = this._queryConfig) !== null && _a !== void 0 ? _a : {});
                }
                /**
                 * Sets continuation token header
                 */
                withContinuationToken(token) {
                    this.withHeaders([
                        {
                            header: continuationTokenHeaderName,
                            value: token
                        }
                    ]);
                    return this;
                }
                getUrl() {
                    const action = '/' + this.taxonomiesEndpoint;
                    return super.resolveUrlInternal(action);
                }
                map(json) {
                    return this.queryService.mappingService.listTaxonomiesResponse(json);
                }
                allResponseFactory(items, responses) {
                    return {
                        items: items,
                        responses: responses
                    };
                }
            }

            class TaxonomyQuery extends BaseQuery {
                constructor(config, queryService, taxonomyCodename) {
                    super(config, queryService);
                    this.config = config;
                    this.queryService = queryService;
                    this.taxonomyCodename = taxonomyCodename;
                    /**
                     * Taxonomies endpoint URL action
                     */
                    this.taxonomiesEndpoint = 'taxonomies';
                    if (!taxonomyCodename) {
                        throw Error(`Cannot create taxonomy query without codename of the taxonomy`);
                    }
                }
                toPromise() {
                    var _a;
                    return this.queryService.getTaxonomy(this.getUrl(), (_a = this._queryConfig) !== null && _a !== void 0 ? _a : {});
                }
                getUrl() {
                    const action = '/' + this.taxonomiesEndpoint + '/' + this.taxonomyCodename;
                    return super.resolveUrlInternal(action);
                }
                map(json) {
                    return this.queryService.mappingService.viewTaxonomyResponse(json);
                }
            }

            class MultipleTypeQuery extends BaseListingQuery {
                constructor(config, queryService) {
                    super(config, queryService);
                    this.config = config;
                    this.queryService = queryService;
                }
                toPromise() {
                    var _a;
                    return this.queryService.getMultipleTypes(this.getUrl(), (_a = this._queryConfig) !== null && _a !== void 0 ? _a : {});
                }
                getUrl() {
                    const action = '/types';
                    return super.resolveUrlInternal(action);
                }
                map(json) {
                    return this.queryService.mappingService.listContentTypesResponse(json);
                }
                allResponseFactory(items, responses) {
                    return {
                        items: items,
                        responses: responses
                    };
                }
            }

            class SingleTypeQuery extends BaseQuery {
                constructor(config, queryService, typeCodename) {
                    super(config, queryService);
                    this.config = config;
                    this.queryService = queryService;
                    this.typeCodename = typeCodename;
                    if (!typeCodename) {
                        throw Error(`Cannot create type query without the codename of the type`);
                    }
                }
                toPromise() {
                    var _a;
                    return this.queryService.getSingleType(this.getUrl(), (_a = this._queryConfig) !== null && _a !== void 0 ? _a : {});
                }
                getUrl() {
                    const action = '/types/' + this.typeCodename;
                    return super.resolveUrlInternal(action);
                }
                map(json) {
                    return this.queryService.mappingService.viewContentTypeResponse(json);
                }
            }

            class ItemsFeedQuery extends BaseListingQuery {
                constructor(config, queryService) {
                    super(config, queryService);
                    this.config = config;
                    this.queryService = queryService;
                }
                /**
                 * Gets only item of given type
                 * @param type Codename of type to get
                 */
                type(type) {
                    this.parameters.push(new Filters.TypeFilter(type));
                    return this;
                }
                /**
                 * Gets items of given types (logical or)
                 * I.e. get items of either 'Actor' or 'Movie' type
                 * @param types Types to get
                 */
                types(types) {
                    this.parameters.push(new Filters.TypeFilter(types));
                    return this;
                }
                /**
                 * Gets only item from given collection
                 * @param collection Codename of collection to get
                 */
                collection(collection) {
                    this.parameters.push(new Filters.CollectionFilter(collection));
                    return this;
                }
                /**
                 * Gets items from given collections (logical or)
                 * I.e. get items of either 'default' or 'christmas-campaign' collection
                 * @param collections Collections to get
                 */
                collections(collections) {
                    this.parameters.push(new Filters.CollectionFilter(collections));
                    return this;
                }
                /**
                 * Language codename
                 * @param languageCodename Codename of the language
                 */
                languageParameter(languageCodename) {
                    this.parameters.push(new Parameters.LanguageParameter(languageCodename));
                    return this;
                }
                /**
                 * Used to limit the number of elements returned by query.
                 * @param elementCodenames Array of element codenames to fetch
                 */
                elementsParameter(elementCodenames) {
                    this.parameters.push(new Parameters.ElementsParameter(elementCodenames));
                    return this;
                }
                toPromise() {
                    var _a;
                    return this.queryService.getItemsFeed(this.getUrl(), (_a = this._queryConfig) !== null && _a !== void 0 ? _a : {});
                }
                getUrl() {
                    const action = '/items-feed';
                    // add default language is necessry
                    this.processDefaultLanguageParameter();
                    return super.resolveUrlInternal(action);
                }
                /**
                 * Used to configure query
                 * @param queryConfig Query configuration
                 */
                queryConfig(queryConfig) {
                    this._queryConfig = queryConfig;
                    return this;
                }
                map(json) {
                    return this.queryService.mappingService.itemsFeedResponse(json);
                }
                allResponseFactory(items, responses) {
                    return {
                        items: items,
                        responses: responses
                    };
                }
            }

            class LanguagesQuery extends BaseListingQuery {
                constructor(config, queryService) {
                    super(config, queryService);
                    this.config = config;
                    this.queryService = queryService;
                    /**
                     * Endpoint
                     */
                    this.endpoint = 'languages';
                }
                /**
                 * Limits the number of taxonomies returned by query
                 * @param limit Number of taxonomies to load
                 */
                limitParameter(limit) {
                    this.parameters.push(new Parameters.LimitParameter(limit));
                    return this;
                }
                /**
                 * Skips the selected number of taxonomies
                 * @param skip Number of taxonomies to skip
                 */
                skipParameter(skip) {
                    this.parameters.push(new Parameters.SkipParameter(skip));
                    return this;
                }
                /**
                 * Sets continuation token header
                 */
                withContinuationToken(token) {
                    this.withHeaders([
                        {
                            header: continuationTokenHeaderName,
                            value: token
                        }
                    ]);
                    return this;
                }
                toPromise() {
                    var _a;
                    return this.queryService.getLanguages(this.getUrl(), (_a = this._queryConfig) !== null && _a !== void 0 ? _a : {});
                }
                getUrl() {
                    const action = '/' + this.endpoint;
                    return super.resolveUrlInternal(action);
                }
                /**
                 * Used to configure query
                 * @param queryConfig Query configuration
                 */
                queryConfig(queryConfig) {
                    this._queryConfig = queryConfig;
                    return this;
                }
                map(json) {
                    return this.queryService.mappingService.listLanguagesResponse(json);
                }
                allResponseFactory(items, responses) {
                    return {
                        items: items,
                        responses: responses
                    };
                }
            }

            const sdkInfo = {
                host: 'npmjs.com',
                version: '11.6.0',
                name: '@kentico/kontent-delivery'
            };

            var __awaiter$1 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
                function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
                return new (P || (P = Promise))(function (resolve, reject) {
                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
                    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
                    step((generator = generator.apply(thisArg, _arguments || [])).next());
                });
            };
            class BaseDeliveryQueryService {
                constructor(
                /**
                 * Delivery client configuration
                 */
                config, 
                /**
                 * Http service for fetching data
                 */
                httpService, 
                /**
                 * Information about the SDK
                 */
                sdkInfo, 
                /**
                 * Mapping service
                 */
                mappingService) {
                    this.config = config;
                    this.httpService = httpService;
                    this.sdkInfo = sdkInfo;
                    this.mappingService = mappingService;
                    /**
                     * Default base Url to Kentico Delivery API
                     */
                    this.defaultBaseDeliveryApiUrl = 'https://deliver.kontent.ai';
                    /**
                     * Default preview url to Kentico Delivery API
                     */
                    this.defaultPreviewDeliveryApiUrl = 'https://preview-deliver.kontent.ai';
                }
                /**
                 * Gets url based on the action, query configuration and options (parameters)
                 * @param action Action (= url part) that will be hit
                 * @param queryConfig Query configuration
                 * @param options Query options
                 */
                getUrl(action, queryConfig, options) {
                    if (!this.config.proxy || !this.config.proxy.advancedProxyUrlResolver) {
                        return urlHelper.addOptionsToUrl(this.getBaseUrl(queryConfig) + action, options);
                    }
                    return this.config.proxy.advancedProxyUrlResolver({
                        queryParameters: options ? options : [],
                        queryString: urlHelper.addOptionsToUrl('', options),
                        action: action,
                        domain: this.getDomain(queryConfig),
                        queryConfig: queryConfig,
                        projectId: this.config.projectId
                    });
                }
                /**
                 * Gets proper set of headers for given request.
                 * @param queryConfig Query configuration
                 * @param additionalHeaders Custom headers
                 */
                getHeaders(queryConfig, additionalHeaders) {
                    const headers = [];
                    if (additionalHeaders) {
                        headers.push(...additionalHeaders);
                    }
                    // add SDK Id header for monitoring SDK usage
                    headers.push(this.getSdkIdHeader());
                    // add headers from global config
                    if (this.config.globalHeaders) {
                        headers.push(...this.config.globalHeaders(queryConfig));
                    }
                    // add query / global headers from query config
                    headers.push(...this.getQueryHeaders(queryConfig));
                    if (this.isPreviewModeEnabled(queryConfig) && this.isSecuredModeEnabled(queryConfig)) {
                        throw Error(`Preview & secured modes cannot be used at the same time.`);
                    }
                    // add preview header is required
                    if (this.isPreviewModeEnabled(queryConfig) && this.config.previewApiKey) {
                        headers.push(this.getAuthorizationHeader(this.config.previewApiKey));
                    }
                    // add secured mode header is required
                    if (this.isSecuredModeEnabled(queryConfig) && this.config.secureApiKey) {
                        headers.push(this.getAuthorizationHeader(this.config.secureApiKey));
                    }
                    // add 'X-KC-Wait-For-Loading-New-Content' header if required
                    if (this.shouldAddWaitForLoadingNewContentHeader(queryConfig)) {
                        headers.push({
                            header: waitForLoadingNewContentHeader,
                            value: 'true'
                        });
                    }
                    return headers;
                }
                /**
                 * Http GET response
                 * @param url Url of request
                 * @param queryConfig Query config configuration
                 */
                getResponseAsync(url, queryConfig, serviceConfig) {
                    return __awaiter$1(this, void 0, void 0, function* () {
                        if (!queryConfig) {
                            queryConfig = {};
                        }
                        if (!serviceConfig) {
                            serviceConfig = {};
                        }
                        try {
                            return yield this.httpService.getAsync({
                                url: url
                            }, {
                                cancelToken: queryConfig === null || queryConfig === void 0 ? void 0 : queryConfig.cancelToken,
                                responseType: 'json',
                                retryStrategy: this.config.retryStrategy,
                                headers: this.getHeaders(queryConfig, serviceConfig.headers ? serviceConfig.headers : [])
                            });
                        }
                        catch (error) {
                            throw this.mapDeliveryError(error);
                        }
                    });
                }
                /**
                 * Gets base URL of the request including the project Id
                 * @param queryConfig Query configuration
                 */
                getBaseUrl(queryConfig) {
                    return this.getDomain(queryConfig) + '/' + this.config.projectId;
                }
                mapNetworkResponse(data, response) {
                    return {
                        data: data,
                        response: response,
                        hasStaleContent: this.getHasStaleContent(response.headers),
                        xContinuationToken: this.getContinuationToken(response.headers)
                    };
                }
                /**
                 * Indicates if current query should use preview mode
                 * @param queryConfig Query configuration
                 */
                isPreviewModeEnabled(queryConfig) {
                    if (queryConfig.usePreviewMode !== undefined) {
                        return queryConfig.usePreviewMode;
                    }
                    if (!this.config.defaultQueryConfig) {
                        return false;
                    }
                    if (this.config.defaultQueryConfig.usePreviewMode === true) {
                        return true;
                    }
                    return false;
                }
                getQueryHeaders(queryConfig) {
                    var _a;
                    if (queryConfig.customHeaders) {
                        return queryConfig.customHeaders;
                    }
                    if ((_a = this.config.defaultQueryConfig) === null || _a === void 0 ? void 0 : _a.customHeaders) {
                        return this.config.defaultQueryConfig.customHeaders;
                    }
                    return [];
                }
                shouldAddWaitForLoadingNewContentHeader(queryConfig) {
                    if (queryConfig.waitForLoadingNewContent !== undefined) {
                        return queryConfig.waitForLoadingNewContent;
                    }
                    if (!this.config.defaultQueryConfig) {
                        return false;
                    }
                    if (this.config.defaultQueryConfig.waitForLoadingNewContent === true) {
                        return true;
                    }
                    return false;
                }
                /**
                 * Indicates if current query should use secured mode
                 * @param queryConfig Query configuration
                 */
                isSecuredModeEnabled(queryConfig) {
                    if (queryConfig.useSecuredMode !== undefined) {
                        return queryConfig.useSecuredMode;
                    }
                    if (!this.config.defaultQueryConfig) {
                        return false;
                    }
                    if (this.config.defaultQueryConfig.useSecuredMode === true) {
                        return true;
                    }
                    return false;
                }
                /**
                 * Gets preview or standard URL based on client and query configuration
                 * @param queryConfig Query configuration
                 */
                getDomain(queryConfig) {
                    if (this.isPreviewModeEnabled(queryConfig)) {
                        if (!this.config.previewApiKey) {
                            throw Error(`Preview API key is not configured.`);
                        }
                        // check custom preview url
                        if (this.config.proxy && this.config.proxy.basePreviewUrl) {
                            return this.config.proxy.basePreviewUrl;
                        }
                        // use default preview url
                        return this.defaultPreviewDeliveryApiUrl;
                    }
                    // check custom base url
                    if (this.config.proxy && this.config.proxy.baseUrl) {
                        return this.config.proxy.baseUrl;
                    }
                    return this.defaultBaseDeliveryApiUrl;
                }
                /**
                 * Gets authorization header. This is used for 'preview' functionality
                 */
                getAuthorizationHeader(key) {
                    if (!key) {
                        throw Error(`Cannot get authorization header because key is invalid`);
                    }
                    // authorization header required for preview mode
                    return {
                        header: 'authorization',
                        value: `bearer ${key}`
                    };
                }
                /**
                 * Header identifying SDK type & version for internal purposes of Kentico
                 */
                getSdkIdHeader() {
                    return {
                        header: sdkVersionHeader,
                        value: `${this.sdkInfo.host};${this.sdkInfo.name};${this.sdkInfo.version}`
                    };
                }
                mapDeliveryError(error) {
                    var _a;
                    let axiosError;
                    if (error.error) {
                        axiosError = error.error;
                    }
                    else {
                        axiosError = error;
                    }
                    if (!axiosError || !axiosError.isAxiosError) {
                        return error;
                    }
                    const deliveryErrorData = (_a = axiosError.response) === null || _a === void 0 ? void 0 : _a.data;
                    if (!deliveryErrorData || !deliveryErrorData.error_code) {
                        return error;
                    }
                    return new DeliveryError({
                        errorCode: deliveryErrorData.error_code,
                        message: deliveryErrorData.message,
                        specificCode: deliveryErrorData.specific_code,
                        requestId: deliveryErrorData.request_id
                    });
                }
                getHasStaleContent(headers) {
                    const hasStaleContentHeader = headers.find((m) => m.header.toLowerCase() === staleContentHeaderName.toLowerCase());
                    if (hasStaleContentHeader) {
                        if (hasStaleContentHeader.value.toString() === '1') {
                            return true;
                        }
                    }
                    return false;
                }
                getContinuationToken(headers) {
                    const header = headers.find((m) => m.header.toLowerCase() === continuationTokenHeaderName.toLowerCase());
                    return header ? header.value : undefined;
                }
            }

            var __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
                function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
                return new (P || (P = Promise))(function (resolve, reject) {
                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
                    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
                    step((generator = generator.apply(thisArg, _arguments || [])).next());
                });
            };
            class QueryService extends BaseDeliveryQueryService {
                constructor(config, httpService, sdkInfo, mappingService) {
                    super(config, httpService, sdkInfo, mappingService);
                }
                /**
                 * Gets single item from given url
                 * @param url Url used to get single item
                 * @param queryConfig Query configuration
                 */
                getSingleItemAsync(url, queryConfig) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.getResponseAsync(url, queryConfig);
                        return this.mapNetworkResponse(this.mappingService.viewContentItemResponse(response.data), response);
                    });
                }
                /**
                 * Gets single feed response. Might not contain all items in your project.
                 * @param url Url
                 * @param queryConfig Query configuration
                 */
                getItemsFeed(url, queryConfig) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.getResponseAsync(url, queryConfig);
                        return this.mapNetworkResponse(this.mappingService.itemsFeedResponse(response.data), response);
                    });
                }
                /**
                 * Gets multiple items from given url
                 * @param url Url used to get multiple items
                 * @param queryConfig Query configuration
                 */
                getMultipleItems(url, queryConfig) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.getResponseAsync(url, queryConfig);
                        return this.mapNetworkResponse(this.mappingService.listContentItemsResponse(response.data), response);
                    });
                }
                /**
                 * Gets single content type from given url
                 * @param url Url used to get single type
                 * @param queryConfig Query configuration
                 */
                getSingleType(url, queryConfig) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.getResponseAsync(url, queryConfig);
                        return this.mapNetworkResponse(this.mappingService.viewContentTypeResponse(response.data), response);
                    });
                }
                /**
                 * Gets multiple content types from given url
                 * @param url Url used to get multiple types
                 * @param queryConfig Query configuration
                 */
                getMultipleTypes(url, queryConfig) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.getResponseAsync(url, queryConfig);
                        return this.mapNetworkResponse(this.mappingService.listContentTypesResponse(response.data), response);
                    });
                }
                /**
                 * Gets languages
                 * @param url Url
                 * @param queryConfig Query configuration
                 */
                getLanguages(url, queryConfig) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.getResponseAsync(url, queryConfig);
                        return this.mapNetworkResponse(this.mappingService.listLanguagesResponse(response.data), response);
                    });
                }
                /**
                 * Gets single taxonomy from given url
                 * @param url Url used to get single taxonomy
                 * @param queryConfig Query configuration
                 */
                getTaxonomy(url, queryConfig) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.getResponseAsync(url, queryConfig);
                        return this.mapNetworkResponse(this.mappingService.viewTaxonomyResponse(response.data), response);
                    });
                }
                /**
                 * Gets multiple taxonomies from given url
                 * @param url Url used to get multiple taxonomies
                 * @param queryConfig Query configuration
                 */
                getTaxonomies(url, queryConfig) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.getResponseAsync(url, queryConfig);
                        return this.mapNetworkResponse(this.mappingService.listTaxonomiesResponse(response.data), response);
                    });
                }
                /**
                 * Gets single content type element from given url
                 * @param url Url used to get single content type element
                 * @param queryConfig Query configuration
                 */
                getElementAsync(url, queryConfig) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.getResponseAsync(url, queryConfig);
                        return this.mapNetworkResponse(this.mappingService.viewContentTypeElementResponse(response.data), response);
                    });
                }
                getListAllResponse(data) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const responses = yield this.getListAllResponseInternalAsync({
                            page: data.page,
                            resolvedResponses: [],
                            getResponse: data.getResponse,
                            nextPageUrl: undefined,
                            continuationToken: undefined,
                            listQueryConfig: data.listQueryConfig
                        });
                        return data.allResponseFactory(responses.reduce((prev, current) => {
                            prev.push(...current.data.items);
                            return prev;
                        }, []), responses);
                    });
                }
                getListAllResponseInternalAsync(data) {
                    var _a, _b, _c, _d, _e;
                    return __awaiter(this, void 0, void 0, function* () {
                        if ((_a = data.listQueryConfig) === null || _a === void 0 ? void 0 : _a.pages) {
                            if (data.page > data.listQueryConfig.pages) {
                                // page limit reached, return result
                                return data.resolvedResponses;
                            }
                        }
                        const response = yield data.getResponse(data.nextPageUrl, data.continuationToken);
                        if ((_b = data.listQueryConfig) === null || _b === void 0 ? void 0 : _b.delayBetweenRequests) {
                            yield this.sleep(data.listQueryConfig.delayBetweenRequests);
                        }
                        data.resolvedResponses.push(response);
                        if ((_c = data.listQueryConfig) === null || _c === void 0 ? void 0 : _c.responseFetched) {
                            data.listQueryConfig.responseFetched(response, data.nextPageUrl, data.continuationToken);
                        }
                        if (((_d = response.data.pagination) === null || _d === void 0 ? void 0 : _d.nextPage) || response.xContinuationToken) {
                            // recursively fetch next page data
                            return yield this.getListAllResponseInternalAsync({
                                page: data.page + 1,
                                nextPageUrl: (_e = response.data.pagination) === null || _e === void 0 ? void 0 : _e.nextPage,
                                continuationToken: response.xContinuationToken,
                                listQueryConfig: data.listQueryConfig,
                                getResponse: data.getResponse,
                                resolvedResponses: data.resolvedResponses
                            });
                        }
                        return data.resolvedResponses;
                    });
                }
                sleep(ms) {
                    return new Promise((resolve) => setTimeout(resolve, ms));
                }
            }

            /**
             * Check if we're required to add a port number.
             *
             * @see https://url.spec.whatwg.org/#default-port
             * @param {Number|String} port Port number we need to check
             * @param {String} protocol Protocol we need to check against.
             * @returns {Boolean} Is it a default port for the given protocol
             * @api private
             */
            var requiresPort = function required(port, protocol) {
              protocol = protocol.split(':')[0];
              port = +port;

              if (!port) return false;

              switch (protocol) {
                case 'http':
                case 'ws':
                return port !== 80;

                case 'https':
                case 'wss':
                return port !== 443;

                case 'ftp':
                return port !== 21;

                case 'gopher':
                return port !== 70;

                case 'file':
                return false;
              }

              return port !== 0;
            };

            var querystringify$1 = {};

            var has = Object.prototype.hasOwnProperty
              , undef;

            /**
             * Decode a URI encoded string.
             *
             * @param {String} input The URI encoded string.
             * @returns {String|Null} The decoded string.
             * @api private
             */
            function decode(input) {
              try {
                return decodeURIComponent(input.replace(/\+/g, ' '));
              } catch (e) {
                return null;
              }
            }

            /**
             * Attempts to encode a given input.
             *
             * @param {String} input The string that needs to be encoded.
             * @returns {String|Null} The encoded string.
             * @api private
             */
            function encode(input) {
              try {
                return encodeURIComponent(input);
              } catch (e) {
                return null;
              }
            }

            /**
             * Simple query string parser.
             *
             * @param {String} query The query string that needs to be parsed.
             * @returns {Object}
             * @api public
             */
            function querystring(query) {
              var parser = /([^=?#&]+)=?([^&]*)/g
                , result = {}
                , part;

              while (part = parser.exec(query)) {
                var key = decode(part[1])
                  , value = decode(part[2]);

                //
                // Prevent overriding of existing properties. This ensures that build-in
                // methods like `toString` or __proto__ are not overriden by malicious
                // querystrings.
                //
                // In the case if failed decoding, we want to omit the key/value pairs
                // from the result.
                //
                if (key === null || value === null || key in result) continue;
                result[key] = value;
              }

              return result;
            }

            /**
             * Transform a query string to an object.
             *
             * @param {Object} obj Object that should be transformed.
             * @param {String} prefix Optional prefix.
             * @returns {String}
             * @api public
             */
            function querystringify(obj, prefix) {
              prefix = prefix || '';

              var pairs = []
                , value
                , key;

              //
              // Optionally prefix with a '?' if needed
              //
              if ('string' !== typeof prefix) prefix = '?';

              for (key in obj) {
                if (has.call(obj, key)) {
                  value = obj[key];

                  //
                  // Edge cases where we actually want to encode the value to an empty
                  // string instead of the stringified value.
                  //
                  if (!value && (value === null || value === undef || isNaN(value))) {
                    value = '';
                  }

                  key = encode(key);
                  value = encode(value);

                  //
                  // If we failed to encode the strings, we should bail out as we don't
                  // want to add invalid strings to the query.
                  //
                  if (key === null || value === null) continue;
                  pairs.push(key +'='+ value);
                }
              }

              return pairs.length ? prefix + pairs.join('&') : '';
            }

            //
            // Expose the module.
            //
            querystringify$1.stringify = querystringify;
            querystringify$1.parse = querystring;

            var required = requiresPort
              , qs = querystringify$1
              , controlOrWhitespace = /^[\x00-\x20\u00a0\u1680\u2000-\u200a\u2028\u2029\u202f\u205f\u3000\ufeff]+/
              , CRHTLF = /[\n\r\t]/g
              , slashes = /^[A-Za-z][A-Za-z0-9+-.]*:\/\//
              , port = /:\d+$/
              , protocolre = /^([a-z][a-z0-9.+-]*:)?(\/\/)?([\\/]+)?([\S\s]*)/i
              , windowsDriveLetter = /^[a-zA-Z]:/;

            /**
             * Remove control characters and whitespace from the beginning of a string.
             *
             * @param {Object|String} str String to trim.
             * @returns {String} A new string representing `str` stripped of control
             *     characters and whitespace from its beginning.
             * @public
             */
            function trimLeft(str) {
              return (str ? str : '').toString().replace(controlOrWhitespace, '');
            }

            /**
             * These are the parse rules for the URL parser, it informs the parser
             * about:
             *
             * 0. The char it Needs to parse, if it's a string it should be done using
             *    indexOf, RegExp using exec and NaN means set as current value.
             * 1. The property we should set when parsing this value.
             * 2. Indication if it's backwards or forward parsing, when set as number it's
             *    the value of extra chars that should be split off.
             * 3. Inherit from location if non existing in the parser.
             * 4. `toLowerCase` the resulting value.
             */
            var rules = [
              ['#', 'hash'],                        // Extract from the back.
              ['?', 'query'],                       // Extract from the back.
              function sanitize(address, url) {     // Sanitize what is left of the address
                return isSpecial(url.protocol) ? address.replace(/\\/g, '/') : address;
              },
              ['/', 'pathname'],                    // Extract from the back.
              ['@', 'auth', 1],                     // Extract from the front.
              [NaN, 'host', undefined, 1, 1],       // Set left over value.
              [/:(\d*)$/, 'port', undefined, 1],    // RegExp the back.
              [NaN, 'hostname', undefined, 1, 1]    // Set left over.
            ];

            /**
             * These properties should not be copied or inherited from. This is only needed
             * for all non blob URL's as a blob URL does not include a hash, only the
             * origin.
             *
             * @type {Object}
             * @private
             */
            var ignore = { hash: 1, query: 1 };

            /**
             * The location object differs when your code is loaded through a normal page,
             * Worker or through a worker using a blob. And with the blobble begins the
             * trouble as the location object will contain the URL of the blob, not the
             * location of the page where our code is loaded in. The actual origin is
             * encoded in the `pathname` so we can thankfully generate a good "default"
             * location from it so we can generate proper relative URL's again.
             *
             * @param {Object|String} loc Optional default location object.
             * @returns {Object} lolcation object.
             * @public
             */
            function lolcation(loc) {
              var globalVar;

              if (typeof window !== 'undefined') globalVar = window;
              else if (typeof commonjsGlobal !== 'undefined') globalVar = commonjsGlobal;
              else if (typeof self !== 'undefined') globalVar = self;
              else globalVar = {};

              var location = globalVar.location || {};
              loc = loc || location;

              var finaldestination = {}
                , type = typeof loc
                , key;

              if ('blob:' === loc.protocol) {
                finaldestination = new Url(unescape(loc.pathname), {});
              } else if ('string' === type) {
                finaldestination = new Url(loc, {});
                for (key in ignore) delete finaldestination[key];
              } else if ('object' === type) {
                for (key in loc) {
                  if (key in ignore) continue;
                  finaldestination[key] = loc[key];
                }

                if (finaldestination.slashes === undefined) {
                  finaldestination.slashes = slashes.test(loc.href);
                }
              }

              return finaldestination;
            }

            /**
             * Check whether a protocol scheme is special.
             *
             * @param {String} The protocol scheme of the URL
             * @return {Boolean} `true` if the protocol scheme is special, else `false`
             * @private
             */
            function isSpecial(scheme) {
              return (
                scheme === 'file:' ||
                scheme === 'ftp:' ||
                scheme === 'http:' ||
                scheme === 'https:' ||
                scheme === 'ws:' ||
                scheme === 'wss:'
              );
            }

            /**
             * @typedef ProtocolExtract
             * @type Object
             * @property {String} protocol Protocol matched in the URL, in lowercase.
             * @property {Boolean} slashes `true` if protocol is followed by "//", else `false`.
             * @property {String} rest Rest of the URL that is not part of the protocol.
             */

            /**
             * Extract protocol information from a URL with/without double slash ("//").
             *
             * @param {String} address URL we want to extract from.
             * @param {Object} location
             * @return {ProtocolExtract} Extracted information.
             * @private
             */
            function extractProtocol(address, location) {
              address = trimLeft(address);
              address = address.replace(CRHTLF, '');
              location = location || {};

              var match = protocolre.exec(address);
              var protocol = match[1] ? match[1].toLowerCase() : '';
              var forwardSlashes = !!match[2];
              var otherSlashes = !!match[3];
              var slashesCount = 0;
              var rest;

              if (forwardSlashes) {
                if (otherSlashes) {
                  rest = match[2] + match[3] + match[4];
                  slashesCount = match[2].length + match[3].length;
                } else {
                  rest = match[2] + match[4];
                  slashesCount = match[2].length;
                }
              } else {
                if (otherSlashes) {
                  rest = match[3] + match[4];
                  slashesCount = match[3].length;
                } else {
                  rest = match[4];
                }
              }

              if (protocol === 'file:') {
                if (slashesCount >= 2) {
                  rest = rest.slice(2);
                }
              } else if (isSpecial(protocol)) {
                rest = match[4];
              } else if (protocol) {
                if (forwardSlashes) {
                  rest = rest.slice(2);
                }
              } else if (slashesCount >= 2 && isSpecial(location.protocol)) {
                rest = match[4];
              }

              return {
                protocol: protocol,
                slashes: forwardSlashes || isSpecial(protocol),
                slashesCount: slashesCount,
                rest: rest
              };
            }

            /**
             * Resolve a relative URL pathname against a base URL pathname.
             *
             * @param {String} relative Pathname of the relative URL.
             * @param {String} base Pathname of the base URL.
             * @return {String} Resolved pathname.
             * @private
             */
            function resolve(relative, base) {
              if (relative === '') return base;

              var path = (base || '/').split('/').slice(0, -1).concat(relative.split('/'))
                , i = path.length
                , last = path[i - 1]
                , unshift = false
                , up = 0;

              while (i--) {
                if (path[i] === '.') {
                  path.splice(i, 1);
                } else if (path[i] === '..') {
                  path.splice(i, 1);
                  up++;
                } else if (up) {
                  if (i === 0) unshift = true;
                  path.splice(i, 1);
                  up--;
                }
              }

              if (unshift) path.unshift('');
              if (last === '.' || last === '..') path.push('');

              return path.join('/');
            }

            /**
             * The actual URL instance. Instead of returning an object we've opted-in to
             * create an actual constructor as it's much more memory efficient and
             * faster and it pleases my OCD.
             *
             * It is worth noting that we should not use `URL` as class name to prevent
             * clashes with the global URL instance that got introduced in browsers.
             *
             * @constructor
             * @param {String} address URL we want to parse.
             * @param {Object|String} [location] Location defaults for relative paths.
             * @param {Boolean|Function} [parser] Parser for the query string.
             * @private
             */
            function Url(address, location, parser) {
              address = trimLeft(address);
              address = address.replace(CRHTLF, '');

              if (!(this instanceof Url)) {
                return new Url(address, location, parser);
              }

              var relative, extracted, parse, instruction, index, key
                , instructions = rules.slice()
                , type = typeof location
                , url = this
                , i = 0;

              //
              // The following if statements allows this module two have compatibility with
              // 2 different API:
              //
              // 1. Node.js's `url.parse` api which accepts a URL, boolean as arguments
              //    where the boolean indicates that the query string should also be parsed.
              //
              // 2. The `URL` interface of the browser which accepts a URL, object as
              //    arguments. The supplied object will be used as default values / fall-back
              //    for relative paths.
              //
              if ('object' !== type && 'string' !== type) {
                parser = location;
                location = null;
              }

              if (parser && 'function' !== typeof parser) parser = qs.parse;

              location = lolcation(location);

              //
              // Extract protocol information before running the instructions.
              //
              extracted = extractProtocol(address || '', location);
              relative = !extracted.protocol && !extracted.slashes;
              url.slashes = extracted.slashes || relative && location.slashes;
              url.protocol = extracted.protocol || location.protocol || '';
              address = extracted.rest;

              //
              // When the authority component is absent the URL starts with a path
              // component.
              //
              if (
                extracted.protocol === 'file:' && (
                  extracted.slashesCount !== 2 || windowsDriveLetter.test(address)) ||
                (!extracted.slashes &&
                  (extracted.protocol ||
                    extracted.slashesCount < 2 ||
                    !isSpecial(url.protocol)))
              ) {
                instructions[3] = [/(.*)/, 'pathname'];
              }

              for (; i < instructions.length; i++) {
                instruction = instructions[i];

                if (typeof instruction === 'function') {
                  address = instruction(address, url);
                  continue;
                }

                parse = instruction[0];
                key = instruction[1];

                if (parse !== parse) {
                  url[key] = address;
                } else if ('string' === typeof parse) {
                  index = parse === '@'
                    ? address.lastIndexOf(parse)
                    : address.indexOf(parse);

                  if (~index) {
                    if ('number' === typeof instruction[2]) {
                      url[key] = address.slice(0, index);
                      address = address.slice(index + instruction[2]);
                    } else {
                      url[key] = address.slice(index);
                      address = address.slice(0, index);
                    }
                  }
                } else if ((index = parse.exec(address))) {
                  url[key] = index[1];
                  address = address.slice(0, index.index);
                }

                url[key] = url[key] || (
                  relative && instruction[3] ? location[key] || '' : ''
                );

                //
                // Hostname, host and protocol should be lowercased so they can be used to
                // create a proper `origin`.
                //
                if (instruction[4]) url[key] = url[key].toLowerCase();
              }

              //
              // Also parse the supplied query string in to an object. If we're supplied
              // with a custom parser as function use that instead of the default build-in
              // parser.
              //
              if (parser) url.query = parser(url.query);

              //
              // If the URL is relative, resolve the pathname against the base URL.
              //
              if (
                  relative
                && location.slashes
                && url.pathname.charAt(0) !== '/'
                && (url.pathname !== '' || location.pathname !== '')
              ) {
                url.pathname = resolve(url.pathname, location.pathname);
              }

              //
              // Default to a / for pathname if none exists. This normalizes the URL
              // to always have a /
              //
              if (url.pathname.charAt(0) !== '/' && isSpecial(url.protocol)) {
                url.pathname = '/' + url.pathname;
              }

              //
              // We should not add port numbers if they are already the default port number
              // for a given protocol. As the host also contains the port number we're going
              // override it with the hostname which contains no port number.
              //
              if (!required(url.port, url.protocol)) {
                url.host = url.hostname;
                url.port = '';
              }

              //
              // Parse down the `auth` for the username and password.
              //
              url.username = url.password = '';

              if (url.auth) {
                index = url.auth.indexOf(':');

                if (~index) {
                  url.username = url.auth.slice(0, index);
                  url.username = encodeURIComponent(decodeURIComponent(url.username));

                  url.password = url.auth.slice(index + 1);
                  url.password = encodeURIComponent(decodeURIComponent(url.password));
                } else {
                  url.username = encodeURIComponent(decodeURIComponent(url.auth));
                }

                url.auth = url.password ? url.username +':'+ url.password : url.username;
              }

              url.origin = url.protocol !== 'file:' && isSpecial(url.protocol) && url.host
                ? url.protocol +'//'+ url.host
                : 'null';

              //
              // The href is just the compiled result.
              //
              url.href = url.toString();
            }

            /**
             * This is convenience method for changing properties in the URL instance to
             * insure that they all propagate correctly.
             *
             * @param {String} part          Property we need to adjust.
             * @param {Mixed} value          The newly assigned value.
             * @param {Boolean|Function} fn  When setting the query, it will be the function
             *                               used to parse the query.
             *                               When setting the protocol, double slash will be
             *                               removed from the final url if it is true.
             * @returns {URL} URL instance for chaining.
             * @public
             */
            function set(part, value, fn) {
              var url = this;

              switch (part) {
                case 'query':
                  if ('string' === typeof value && value.length) {
                    value = (fn || qs.parse)(value);
                  }

                  url[part] = value;
                  break;

                case 'port':
                  url[part] = value;

                  if (!required(value, url.protocol)) {
                    url.host = url.hostname;
                    url[part] = '';
                  } else if (value) {
                    url.host = url.hostname +':'+ value;
                  }

                  break;

                case 'hostname':
                  url[part] = value;

                  if (url.port) value += ':'+ url.port;
                  url.host = value;
                  break;

                case 'host':
                  url[part] = value;

                  if (port.test(value)) {
                    value = value.split(':');
                    url.port = value.pop();
                    url.hostname = value.join(':');
                  } else {
                    url.hostname = value;
                    url.port = '';
                  }

                  break;

                case 'protocol':
                  url.protocol = value.toLowerCase();
                  url.slashes = !fn;
                  break;

                case 'pathname':
                case 'hash':
                  if (value) {
                    var char = part === 'pathname' ? '/' : '#';
                    url[part] = value.charAt(0) !== char ? char + value : value;
                  } else {
                    url[part] = value;
                  }
                  break;

                case 'username':
                case 'password':
                  url[part] = encodeURIComponent(value);
                  break;

                case 'auth':
                  var index = value.indexOf(':');

                  if (~index) {
                    url.username = value.slice(0, index);
                    url.username = encodeURIComponent(decodeURIComponent(url.username));

                    url.password = value.slice(index + 1);
                    url.password = encodeURIComponent(decodeURIComponent(url.password));
                  } else {
                    url.username = encodeURIComponent(decodeURIComponent(value));
                  }
              }

              for (var i = 0; i < rules.length; i++) {
                var ins = rules[i];

                if (ins[4]) url[ins[1]] = url[ins[1]].toLowerCase();
              }

              url.auth = url.password ? url.username +':'+ url.password : url.username;

              url.origin = url.protocol !== 'file:' && isSpecial(url.protocol) && url.host
                ? url.protocol +'//'+ url.host
                : 'null';

              url.href = url.toString();

              return url;
            }

            /**
             * Transform the properties back in to a valid and full URL string.
             *
             * @param {Function} stringify Optional query stringify function.
             * @returns {String} Compiled version of the URL.
             * @public
             */
            function toString(stringify) {
              if (!stringify || 'function' !== typeof stringify) stringify = qs.stringify;

              var query
                , url = this
                , host = url.host
                , protocol = url.protocol;

              if (protocol && protocol.charAt(protocol.length - 1) !== ':') protocol += ':';

              var result =
                protocol +
                ((url.protocol && url.slashes) || isSpecial(url.protocol) ? '//' : '');

              if (url.username) {
                result += url.username;
                if (url.password) result += ':'+ url.password;
                result += '@';
              } else if (url.password) {
                result += ':'+ url.password;
                result += '@';
              } else if (
                url.protocol !== 'file:' &&
                isSpecial(url.protocol) &&
                !host &&
                url.pathname !== '/'
              ) {
                //
                // Add back the empty userinfo, otherwise the original invalid URL
                // might be transformed into a valid one with `url.pathname` as host.
                //
                result += '@';
              }

              //
              // Trailing colon is removed from `url.host` when it is parsed. If it still
              // ends with a colon, then add back the trailing colon that was removed. This
              // prevents an invalid URL from being transformed into a valid one.
              //
              if (host[host.length - 1] === ':' || (port.test(url.hostname) && !url.port)) {
                host += ':';
              }

              result += host + url.pathname;

              query = 'object' === typeof url.query ? stringify(url.query) : url.query;
              if (query) result += '?' !== query.charAt(0) ? '?'+ query : query;

              if (url.hash) result += url.hash;

              return result;
            }

            Url.prototype = { set: set, toString: toString };

            //
            // Expose the URL parser and some additional properties that might be useful for
            // others or testing.
            //
            Url.extractProtocol = extractProtocol;
            Url.location = lolcation;
            Url.trimLeft = trimLeft;
            Url.qs = qs;

            var urlParse = Url;

            var urlParse$1 = /*#__PURE__*/Object.freeze(/*#__PURE__*/Object.assign(/*#__PURE__*/Object.create(null), urlParse, {
                'default': urlParse
            }));

            class DeliveryUrlHelper {
                replaceAssetDomain(originalAssetUrl, customDomain) {
                    const urlPath = this.getUrlPathname(originalAssetUrl);
                    return `${customDomain}${urlPath}`;
                }
                getUrlPathname(url) {
                    const parsedUrl = urlParse$1(url);
                    return parsedUrl.pathname;
                }
            }
            const deliveryUrlHelper = new DeliveryUrlHelper();

            /**
            * Represents codename of Kentico Kontent element types
            */
            var ElementType;
            (function (ElementType) {
                ElementType["Text"] = "text";
                ElementType["Number"] = "number";
                ElementType["ModularContent"] = "modular_content";
                ElementType["Asset"] = "asset";
                ElementType["DateTime"] = "date_time";
                ElementType["RichText"] = "rich_text";
                ElementType["MultipleChoice"] = "multiple_choice";
                ElementType["UrlSlug"] = "url_slug";
                ElementType["Taxonomy"] = "taxonomy";
                ElementType["Custom"] = "custom";
                ElementType["Unknown"] = "unknown";
            })(ElementType || (ElementType = {}));

            class ElementMapper {
                constructor(config) {
                    this.config = config;
                }
                mapElements(data) {
                    // return processed item to avoid infinite recursion
                    const processedItem = data.processedItems[data.dataToMap.item.system.codename];
                    if (processedItem) {
                        // item was already resolved
                        return {
                            item: processedItem,
                            processedItems: data.processedItems,
                            preparedItems: data.preparedItems,
                            processingStartedForCodenames: data.processingStartedForCodenames
                        };
                    }
                    const preparedItem = data.preparedItems[data.dataToMap.item.system.codename];
                    const itemInstance = preparedItem === null || preparedItem === void 0 ? void 0 : preparedItem.item;
                    if (!itemInstance) {
                        // item is not present in response
                        return undefined;
                    }
                    // mapp elements
                    const elementCodenames = Object.getOwnPropertyNames(data.dataToMap.rawItem.elements);
                    for (const elementCodename of elementCodenames) {
                        const elementMap = this.resolveElementMap(itemInstance, elementCodename);
                        const elementWrapper = {
                            system: data.dataToMap.item.system,
                            rawElement: data.dataToMap.rawItem.elements[elementCodename],
                            element: elementMap.resolvedName
                        };
                        if (elementMap.shouldMapElement) {
                            const mappedElement = this.mapElement({
                                elementWrapper: elementWrapper,
                                item: itemInstance,
                                preparedItems: data.preparedItems,
                                processingStartedForCodenames: data.processingStartedForCodenames,
                                processedItems: data.processedItems
                            });
                            // set mapped elements
                            itemInstance.elements[elementMap.resolvedName] = mappedElement;
                        }
                    }
                    return {
                        item: itemInstance,
                        processedItems: data.processedItems,
                        preparedItems: data.preparedItems,
                        processingStartedForCodenames: data.processingStartedForCodenames
                    };
                }
                mapElement(data) {
                    const elementType = enumHelper.getEnumFromValue(ElementType, data.elementWrapper.rawElement.type);
                    if (elementType) {
                        if (elementType === ElementType.ModularContent) {
                            return this.mapLinkedItemsElement({
                                elementWrapper: data.elementWrapper,
                                preparedItems: data.preparedItems,
                                processingStartedForCodenames: data.processingStartedForCodenames,
                                processedItems: data.processedItems
                            });
                        }
                        if (elementType === ElementType.Text) {
                            return this.mapTextElement(data.elementWrapper);
                        }
                        if (elementType === ElementType.Asset) {
                            return this.mapAssetsElement(data.elementWrapper);
                        }
                        if (elementType === ElementType.Number) {
                            return this.mapNumberElement(data.elementWrapper);
                        }
                        if (elementType === ElementType.MultipleChoice) {
                            return this.mapMultipleChoiceElement(data.elementWrapper);
                        }
                        if (elementType === ElementType.DateTime) {
                            return this.mapDateTimeElement(data.elementWrapper);
                        }
                        if (elementType === ElementType.RichText) {
                            // add to parent items
                            return this.mapRichTextElement(data.elementWrapper, data.processedItems, data.processingStartedForCodenames, data.preparedItems);
                        }
                        if (elementType === ElementType.UrlSlug) {
                            return this.mapUrlSlugElement(data.elementWrapper);
                        }
                        if (elementType === ElementType.Taxonomy) {
                            return this.mapTaxonomyElement(data.elementWrapper);
                        }
                        if (elementType === ElementType.Custom) {
                            return this.mapCustomElement(data.elementWrapper);
                        }
                    }
                    console.warn(`Could not map element '${data.elementWrapper.rawElement.name}' of type '${data.elementWrapper.rawElement.type}'. Returning unknown element instead.`);
                    return this.mapUnknowElement(data.elementWrapper);
                }
                mapRichTextElement(elementWrapper, processedItems, processingStartedForCodenames, preparedItems) {
                    // get all linked items nested in rich text
                    const richTextLinkedItems = [];
                    const rawElement = elementWrapper.rawElement;
                    for (const codename of rawElement.modular_content) {
                        // get linked item and check if it exists (it might not be included in response due to 'Depth' parameter)
                        const preparedData = preparedItems[codename];
                        // first try to get existing item
                        if (this.canMapLinkedItems()) {
                            const existingLinkedItem = this.getOrSaveLinkedItemForElement(codename, rawElement, processedItems, processingStartedForCodenames, preparedItems);
                            if (existingLinkedItem) {
                                // item was found, add it to linked items
                                richTextLinkedItems.push(existingLinkedItem);
                            }
                            else {
                                // item was not found or not yet resolved
                                if (preparedData) {
                                    const mappedLinkedItemResult = this.mapElements({
                                        dataToMap: preparedData,
                                        preparedItems: preparedItems,
                                        processingStartedForCodenames: processingStartedForCodenames,
                                        processedItems: processedItems
                                    });
                                    // add mapped linked item to result
                                    if (mappedLinkedItemResult) {
                                        richTextLinkedItems.push(mappedLinkedItemResult.item);
                                    }
                                }
                            }
                        }
                    }
                    // get rich text images
                    const richTextImagesResult = this.getRichTextImages(rawElement.images);
                    // extract and map links & images
                    const links = this.mapRichTextLinks(rawElement.links);
                    const images = richTextImagesResult.richTextImages;
                    // replace asset urls in html
                    const richTextHtml = this.getRichTextHtml(rawElement.value, richTextImagesResult.imageUrlRecords);
                    return {
                        images: images,
                        linkedItemCodenames: rawElement.modular_content,
                        linkedItems: richTextLinkedItems,
                        links: links,
                        name: rawElement.name,
                        type: ElementType.RichText,
                        value: richTextHtml
                    };
                }
                mapDateTimeElement(elementWrapper) {
                    return this.buildElement(elementWrapper, ElementType.DateTime, () => elementWrapper.rawElement.value);
                }
                mapMultipleChoiceElement(elementWrapper) {
                    return this.buildElement(elementWrapper, ElementType.MultipleChoice, () => elementWrapper.rawElement.value);
                }
                mapNumberElement(elementWrapper) {
                    return this.buildElement(elementWrapper, ElementType.Number, () => {
                        if (elementWrapper.rawElement.value === 0) {
                            return 0;
                        }
                        else if (elementWrapper.rawElement.value) {
                            return +elementWrapper.rawElement.value;
                        }
                        return null;
                    });
                }
                mapTextElement(elementWrapper) {
                    return this.buildElement(elementWrapper, ElementType.Text, () => elementWrapper.rawElement.value);
                }
                mapAssetsElement(elementWrapper) {
                    return this.buildElement(elementWrapper, ElementType.Asset, () => {
                        var _a;
                        const assetContracts = elementWrapper.rawElement.value;
                        const assets = [];
                        for (const assetContract of assetContracts) {
                            let renditions = null;
                            // get asset url (custom domain may be configured)
                            const assetUrl = this.config.assetsDomain
                                ? deliveryUrlHelper.replaceAssetDomain(assetContract.url, this.config.assetsDomain)
                                : assetContract.url;
                            if (assetContract.renditions) {
                                renditions = {};
                                for (const renditionPresetKey of Object.keys(assetContract.renditions)) {
                                    const rendition = assetContract.renditions[renditionPresetKey];
                                    renditions[renditionPresetKey] = Object.assign(Object.assign({}, rendition), { url: `${assetUrl}?${rendition.query}` // enhance rendition with absolute url
                                     });
                                }
                            }
                            const renditionToBeApplied = (this.config.defaultRenditionPreset && (renditions === null || renditions === void 0 ? void 0 : renditions[this.config.defaultRenditionPreset])) || null;
                            const finalUrl = (_a = renditionToBeApplied === null || renditionToBeApplied === void 0 ? void 0 : renditionToBeApplied.url) !== null && _a !== void 0 ? _a : assetUrl;
                            const asset = Object.assign(Object.assign({}, assetContract), { url: finalUrl, // use custom url of asset which may contain custom domain and applied rendition
                                renditions });
                            assets.push(asset);
                        }
                        return assets;
                    });
                }
                mapTaxonomyElement(elementWrapper) {
                    var _a;
                    return Object.assign(Object.assign({}, this.buildElement(elementWrapper, ElementType.Taxonomy, () => elementWrapper.rawElement.value)), { taxonomyGroup: (_a = elementWrapper.rawElement.taxonomy_group) !== null && _a !== void 0 ? _a : null });
                }
                mapUnknowElement(elementWrapper) {
                    return this.buildElement(elementWrapper, ElementType.Unknown, () => elementWrapper.rawElement.value);
                }
                mapCustomElement(elementWrapper) {
                    // try to find element resolver
                    if (this.config.elementResolver) {
                        const elementResolverValue = this.config.elementResolver(elementWrapper);
                        if (elementResolverValue) {
                            return this.buildElement(elementWrapper, ElementType.Custom, () => elementResolverValue);
                        }
                    }
                    return this.buildElement(elementWrapper, ElementType.Custom, () => elementWrapper.rawElement.value);
                }
                mapUrlSlugElement(elementWrapper) {
                    return this.buildElement(elementWrapper, ElementType.UrlSlug, () => elementWrapper.rawElement.value);
                }
                mapLinkedItemsElement(data) {
                    // prepare linked items
                    const linkedItems = [];
                    // value = array of item codenames
                    const linkedItemCodenames = data.elementWrapper.rawElement.value;
                    for (const codename of linkedItemCodenames) {
                        if (this.canMapLinkedItems()) {
                            const linkedItem = this.getOrSaveLinkedItemForElement(codename, data.elementWrapper.rawElement, data.processedItems, data.processingStartedForCodenames, data.preparedItems);
                            if (linkedItem) {
                                // add item to result
                                linkedItems.push(linkedItem);
                            }
                        }
                    }
                    return Object.assign(Object.assign({}, this.buildElement(data.elementWrapper, ElementType.ModularContent, () => linkedItemCodenames)), { linkedItems: linkedItems });
                }
                getOrSaveLinkedItemForElement(codename, element, processedItems, mappingStartedForCodenames, preparedItems) {
                    // first check if item was already resolved and return it if it was
                    const processedItem = processedItems[codename];
                    if (processedItem) {
                        // item was already resolved
                        return processedItem;
                    }
                    const preparedItem = preparedItems[codename];
                    if (mappingStartedForCodenames.includes(codename)) {
                        return preparedItem === null || preparedItem === void 0 ? void 0 : preparedItem.item;
                    }
                    mappingStartedForCodenames.push(codename);
                    // throw error if item is not in response and errors are not skipped
                    if (!preparedItem) {
                        return undefined;
                    }
                    let mappedLinkedItem;
                    // original resolving if item is still undefined
                    const mappedLinkedItemResult = this.mapElements({
                        dataToMap: preparedItem,
                        preparedItems: preparedItems,
                        processingStartedForCodenames: mappingStartedForCodenames,
                        processedItems: processedItems
                    });
                    if (mappedLinkedItemResult) {
                        mappedLinkedItem = mappedLinkedItemResult.item;
                        // add to processed items
                        processedItems[codename] = mappedLinkedItem;
                    }
                    return mappedLinkedItem;
                }
                mapRichTextLinks(linksJson) {
                    const links = [];
                    for (const linkId of Object.keys(linksJson)) {
                        const linkRaw = linksJson[linkId];
                        links.push({
                            codename: linkRaw.codename,
                            linkId: linkId,
                            urlSlug: linkRaw.url_slug,
                            type: linkRaw.type
                        });
                    }
                    return links;
                }
                getRichTextHtml(richTextHtml, richTextImageRecords) {
                    for (const richTextImageRecord of richTextImageRecords) {
                        // replace rich text image url if it differs
                        if (richTextImageRecord.newUrl !== richTextImageRecord.originalUrl) {
                            richTextHtml = richTextHtml.replace(new RegExp(richTextImageRecord.originalUrl, 'g'), richTextImageRecord.newUrl);
                        }
                    }
                    return richTextHtml;
                }
                getRichTextImages(imagesJson) {
                    var _a, _b, _c;
                    const images = [];
                    const imageUrlRecords = [];
                    for (const imageId of Object.keys(imagesJson)) {
                        const imageRaw = imagesJson[imageId];
                        // image may contain custom asset domain
                        const imageUrl = this.config.assetsDomain
                            ? deliveryUrlHelper.replaceAssetDomain(imageRaw.url, this.config.assetsDomain)
                            : imageRaw.url;
                        images.push({
                            description: (_a = imageRaw.description) !== null && _a !== void 0 ? _a : null,
                            imageId: imageRaw.image_id,
                            url: imageUrl,
                            height: (_b = imageRaw.height) !== null && _b !== void 0 ? _b : null,
                            width: (_c = imageRaw.width) !== null && _c !== void 0 ? _c : null
                        });
                        imageUrlRecords.push({
                            originalUrl: imageRaw.url,
                            newUrl: imageUrl
                        });
                    }
                    return {
                        imageUrlRecords: imageUrlRecords,
                        richTextImages: images
                    };
                }
                resolveElementMap(item, originalElementCodename) {
                    let resolvedElementPropertyName = undefined;
                    if (this.config.propertyNameResolver) {
                        resolvedElementPropertyName = this.config.propertyNameResolver(item.system.type, originalElementCodename);
                    }
                    if (!resolvedElementPropertyName) {
                        // use original element codename
                        resolvedElementPropertyName = originalElementCodename;
                    }
                    return {
                        resolvedName: resolvedElementPropertyName,
                        shouldMapElement: true
                    };
                }
                buildElement(elementWrapper, type, valueFactory) {
                    return {
                        name: elementWrapper.rawElement.name,
                        type: type,
                        value: valueFactory()
                    };
                }
                canMapLinkedItems() {
                    if (!this.config.linkedItemsReferenceHandler) {
                        return true;
                    }
                    return this.config.linkedItemsReferenceHandler === 'map';
                }
            }

            class ItemMapper {
                constructor(config) {
                    this.config = config;
                    this.elementMapper = new ElementMapper(config);
                }
                /**
                 * Maps single item to its proper strongly typed model from the given Kontent response
                 * @param response Kontent response used to map the item
                 * @param queryConfig Query configuration
                 */
                mapSingleItemFromResponse(response) {
                    const mapResult = this.mapItems({
                        mainItems: [response.item],
                        linkedItems: Object.values(response.modular_content),
                    });
                    return {
                        item: mapResult.items[0],
                        linkedItems: mapResult.linkedItems
                    };
                }
                /**
                 * Maps multiple items to their strongly typed model from the given Kontent response
                 * @param response Kontent response used to map the item
                 * @param queryConfig Query configuration
                 */
                mapMultipleItemsFromResponse(response) {
                    const mapResult = this.mapItems({
                        mainItems: response.items,
                        linkedItems: Object.values(response.modular_content)
                    });
                    return mapResult;
                }
                /**
                 * Maps item contracts to full models
                 */
                mapItems(data) {
                    const that = this;
                    const processedItems = {};
                    const preparedItems = {};
                    const processingStartedForCodenames = [];
                    const mappedMainItems = [];
                    const mappedLinkedItems = {};
                    const itemsToResolve = [...data.mainItems, ...data.linkedItems];
                    // first prepare reference for all items
                    for (const item of itemsToResolve) {
                        preparedItems[item.system.codename] = {
                            item: this.createContentItem(item),
                            rawItem: item
                        };
                    }
                    // then resolve items
                    for (const item of data.mainItems) {
                        const itemResult = that.mapItem({
                            item: preparedItems[item.system.codename],
                            processedItems: processedItems,
                            preparedItems: preparedItems,
                            processingStartedForCodenames: processingStartedForCodenames
                        });
                        mappedMainItems.push(itemResult.item);
                    }
                    for (const item of data.linkedItems) {
                        const itemResult = that.mapItem({
                            item: preparedItems[item.system.codename],
                            processedItems: processedItems,
                            preparedItems: preparedItems,
                            processingStartedForCodenames: processingStartedForCodenames
                        });
                        mappedLinkedItems[item.system.codename] = itemResult.item;
                    }
                    return {
                        items: mappedMainItems,
                        linkedItems: mappedLinkedItems
                    };
                }
                /**
                 * Maps item contract to full model
                 */
                mapItem(data) {
                    if (!data.item) {
                        throw Error(`Could not map item because its undefined`);
                    }
                    const result = this.elementMapper.mapElements({
                        dataToMap: data.item,
                        preparedItems: data.preparedItems,
                        processingStartedForCodenames: [],
                        processedItems: data.processedItems,
                    });
                    if (!result) {
                        throw Error(`Mapping of content item '${data.item.item.system.codename}' failed`);
                    }
                    return {
                        item: result.item,
                        processedItems: result.processedItems,
                        preparedItems: result.preparedItems,
                        processingStartedForCodenames: result.processingStartedForCodenames
                    };
                }
                createContentItem(item) {
                    var _a;
                    const contentItem = {
                        elements: {},
                        system: {
                            codename: item.system.codename,
                            collection: item.system.collection,
                            id: item.system.id,
                            language: item.system.language,
                            lastModified: item.system.last_modified,
                            name: item.system.name,
                            sitemapLocations: item.system.sitemap_locations,
                            type: item.system.type,
                            workflowStep: (_a = item.system.workflow_step) !== null && _a !== void 0 ? _a : null
                        }
                    };
                    return contentItem;
                }
            }

            class TaxonomyMapper {
                mapTaxonomy(taxonomySystem, taxonomyTerms) {
                    if (!taxonomySystem) {
                        throw Error(`Cannot map taxonomy due to missing 'system' property`);
                    }
                    if (!taxonomyTerms) {
                        throw Error(`Cannot map taxonomy due to missing 'terms' property`);
                    }
                    if (!Array.isArray(taxonomyTerms)) {
                        throw Error(`Cannot map terms because no terms array was provided`);
                    }
                    const mappedSystemAttributes = {
                        name: taxonomySystem.name,
                        codename: taxonomySystem.codename,
                        id: taxonomySystem.id,
                        lastModified: taxonomySystem.last_modified
                    };
                    const mappedTerms = this.mapTaxonomyTerms(taxonomyTerms);
                    return {
                        system: mappedSystemAttributes,
                        terms: mappedTerms
                    };
                }
                mapTaxonomies(taxonomies) {
                    if (!taxonomies) {
                        throw Error(`Cannot map taxonomy due to missing 'taxonomies' property`);
                    }
                    if (!Array.isArray(taxonomies)) {
                        throw Error(`Cannot map taxonomies because the 'taxonomies' property is not an array `);
                    }
                    const mappedTaxonomies = [];
                    taxonomies.forEach((taxonomy) => {
                        mappedTaxonomies.push(this.mapTaxonomy(taxonomy.system, taxonomy.terms));
                    });
                    return mappedTaxonomies;
                }
                /**
                 * Recursively map array of taxonomy terms
                 * @param termsArray Terms array to map
                 */
                mapTaxonomyTerms(termsArray) {
                    if (termsArray.length === 0) {
                        return [];
                    }
                    const mappedTermsArray = [];
                    termsArray.forEach((terms) => {
                        const mappedTerms = {
                            codename: terms.codename,
                            name: terms.name,
                            terms: this.mapTaxonomyTerms(terms.terms)
                        };
                        mappedTermsArray.push(mappedTerms);
                    });
                    return mappedTermsArray;
                }
            }

            class TypeMapper {
                mapSingleType(response) {
                    return this.mapType(response);
                }
                mapMultipleTypes(response) {
                    const that = this;
                    return response.types.map(function (type) {
                        return that.mapType(type);
                    });
                }
                mapType(type) {
                    if (!type) {
                        throw Error(`Cannot map type`);
                    }
                    if (!type.elements) {
                        throw Error(`Cannot map type elements`);
                    }
                    const system = {
                        codename: type.system.codename,
                        id: type.system.id,
                        name: type.system.name,
                        lastModified: type.system.last_modified
                    };
                    const elements = [];
                    const elementNames = Object.getOwnPropertyNames(type.elements);
                    elementNames.forEach((elementName) => {
                        const typeElement = type.elements[elementName];
                        if (!typeElement) {
                            throw Error(`Cannot find element '${elementName}' on type '${type}'`);
                        }
                        // use json property as a codename of the type element
                        const elementCodename = elementName;
                        // extra properties for certain element types
                        const taxonomyGroup = typeElement.taxonomy_group;
                        const options = [];
                        // some elements can contain options
                        const rawOptions = typeElement.options;
                        if (rawOptions) {
                            if (!Array.isArray(rawOptions)) {
                                throw Error(`Content type 'options' property has to be an array`);
                            }
                            rawOptions.forEach((rawOption) => {
                                options.push({
                                    codename: rawOption.codename,
                                    name: rawOption.name
                                });
                            });
                        }
                        elements.push({
                            codename: elementCodename,
                            taxonomyGroup: taxonomyGroup,
                            options: options,
                            name: typeElement.name,
                            type: typeElement.type
                        });
                    });
                    return {
                        elements: elements,
                        system: system
                    };
                }
            }

            class GenericElementMapper {
                mapElement(response) {
                    if (!response) {
                        throw Error(`Invalid response for mapping element`);
                    }
                    return {
                        codename: response.codename,
                        name: response.name,
                        type: response.type,
                        options: response.options ? response.options : [],
                        taxonomyGroup: response.taxonomy_group
                    };
                }
            }

            class LanguageMapper {
                mapMultipleLanguages(response) {
                    return response.languages.map((language) => {
                        return this.mapLanguage(language);
                    });
                }
                mapLanguage(language) {
                    if (!language) {
                        throw Error(`Cannot map language`);
                    }
                    return {
                        system: language.system
                    };
                }
            }

            class MappingService {
                constructor(config) {
                    this.config = config;
                    this.typeMapper = new TypeMapper();
                    this.languageMapper = new LanguageMapper();
                    this.itemMapper = new ItemMapper(config);
                    this.taxonomyMapper = new TaxonomyMapper();
                    this.genericElementMapper = new GenericElementMapper();
                }
                /**
                 * Gets response for list of languages
                 * @param data Response data
                 */
                listLanguagesResponse(data) {
                    return {
                        items: this.languageMapper.mapMultipleLanguages(data),
                        pagination: this.mapPagination(data.pagination)
                    };
                }
                /**
                 * Gets response for getting a multiple type
                 * @param data Response data
                 */
                listContentTypesResponse(data) {
                    return {
                        items: this.typeMapper.mapMultipleTypes(data),
                        pagination: this.mapPagination(data.pagination)
                    };
                }
                /**
                 * Gets response for single type
                 * @param data Response data
                 * @param options Options
                 */
                viewContentTypeResponse(data) {
                    return {
                        type: this.typeMapper.mapSingleType(data)
                    };
                }
                itemsFeedResponse(data) {
                    const itemsResult = this.itemMapper.mapItems({
                        linkedItems: Object.values(data.modular_content),
                        mainItems: data.items
                    });
                    return {
                        items: itemsResult.items,
                        linkedItems: itemsResult.linkedItems
                    };
                }
                /**
                 * Gets response for getting single item
                 * @param data Response data
                 * @param queryConfig Query configuration
                 */
                viewContentItemResponse(data) {
                    const itemResult = this.itemMapper.mapSingleItemFromResponse(data);
                    return {
                        item: itemResult.item,
                        linkedItems: itemResult.linkedItems
                    };
                }
                /**
                 * Gets response for getting multiple items
                 * @param data Response data
                 * @param queryConfig Query configuration
                 */
                listContentItemsResponse(data) {
                    const itemsResult = this.itemMapper.mapMultipleItemsFromResponse(data);
                    return {
                        items: itemsResult.items,
                        pagination: this.mapPagination(data.pagination),
                        linkedItems: itemsResult.linkedItems
                    };
                }
                /**
                 * Gets response for getting single taxonomy item
                 * @param data Response data
                 */
                viewTaxonomyResponse(data) {
                    return {
                        taxonomy: this.taxonomyMapper.mapTaxonomy(data.system, data.terms)
                    };
                }
                /**
                 * Gets response for getting multiples taxonomies
                 * @param data Response data
                 */
                listTaxonomiesResponse(data) {
                    return {
                        items: this.taxonomyMapper.mapTaxonomies(data.taxonomies),
                        pagination: this.mapPagination(data.pagination)
                    };
                }
                /**
                 * Gets response for getting single content type element
                 * @param data Response data
                 */
                viewContentTypeElementResponse(data) {
                    return {
                        element: this.genericElementMapper.mapElement(data)
                    };
                }
                mapPagination(paginationContract) {
                    var _a;
                    return {
                        skip: paginationContract.skip,
                        count: paginationContract.count,
                        limit: paginationContract.limit,
                        nextPage: paginationContract.next_page,
                        totalCount: (_a = paginationContract.total_count) !== null && _a !== void 0 ? _a : null
                    };
                }
            }

            class DeliveryClient {
                /**
                 * Delivery client used to fetch data from Kentico Kontent
                 * @constructor
                 * @param {IDeliveryClientConfig} config - The client configuration
                 */
                constructor(config) {
                    this.config = config;
                    if (!config) {
                        throw Error(`Delivery client configuration is not set`);
                    }
                    this.mappingService = new MappingService(config);
                    this.queryService = new QueryService(config, config.httpService ? config.httpService : new HttpService(), {
                        host: sdkInfo.host,
                        name: sdkInfo.name,
                        version: sdkInfo.version
                    }, this.mappingService);
                }
                /**
                 * Gets query for multiple languages
                 */
                languages() {
                    return new LanguagesQuery(this.config, this.queryService);
                }
                /**
                 * Gets query for multiple types
                 */
                types() {
                    return new MultipleTypeQuery(this.config, this.queryService);
                }
                /**
                 * Gets query for single type
                 * @param {string} typeCodename - Codename of the type to fetch
                 */
                type(typeCodename) {
                    return new SingleTypeQuery(this.config, this.queryService, typeCodename);
                }
                /**
                 * Gets query for multiple items
                 */
                items() {
                    return new MultipleItemsQuery(this.config, this.queryService);
                }
                /**
                 * Gets query for single item
                 * @param {string} codename - Codename of item to fetch
                 */
                item(codename) {
                    return new SingleItemQuery(this.config, this.queryService, codename);
                }
                /**
                 * Gets query for items feed. Executes single HTTP request only. Might not get all items from your Kontent project.
                 */
                itemsFeed() {
                    return new ItemsFeedQuery(this.config, this.queryService);
                }
                /**
                 * Gets query for single taxonomy
                 * @param {string} codename - Codename of taxonomy to fetch
                 */
                taxonomy(codename) {
                    return new TaxonomyQuery(this.config, this.queryService, codename);
                }
                /**
                 * Gets query for multiple taxonomies
                 */
                taxonomies() {
                    return new TaxonomiesQuery(this.config, this.queryService);
                }
                /**
                 * Gets query for an element within a type
                 * @param {string} typeCodename - Codename of the type
                 * @param {string} elementCodename - Codename of the element
                 */
                element(typeCodename, elementCodename) {
                    return new ElementQuery(this.config, this.queryService, typeCodename, elementCodename);
                }
            }

            function createDeliveryClient(config) {
                return new DeliveryClient(config);
            }

            (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
                function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
                return new (P || (P = Promise))(function (resolve, reject) {
                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
                    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
                    step((generator = generator.apply(thisArg, _arguments || [])).next());
                });
            };

            (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
                function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
                return new (P || (P = Promise))(function (resolve, reject) {
                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
                    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
                    step((generator = generator.apply(thisArg, _arguments || [])).next());
                });
            };

            const pluginId = pkg.name;
            registerDataPlugin({
              id: pluginId,
              name: "Kontent.ai",
              icon: "https://cdn.builder.io/api/v1/image/assets%2Fe85723a1cdde410591c232f4b375ef9b%2F2a37f60f2d234039af6284f35ae81a61",
              settings: [
                {
                  name: "projectId",
                  type: "string",
                  required: true,
                  helperText: 'Get your project ID from "Project Settings" > "API keys"'
                }
              ],
              ctaText: `Connect your project`
            }, async (settings) => {
              const projectId = settings.get("projectId")?.trim();
              const client = createDeliveryClient({
                projectId
              });
              return {
                async getResourceTypes() {
                  const languagesResponse = await client.languages().toAllPromise();
                  const languagesEnum = languagesResponse.data.items.map((language) => ({
                    value: language.system.codename,
                    label: language.system.name
                  })).concat([
                    {
                      label: "Dynamic (bound to state)",
                      value: '{{state.locale || ""}}'
                    }
                  ]);
                  const result = await client.types().toAllPromise();
                  return result.data.items.map((type) => ({
                    name: type.system.name,
                    id: type.system.codename,
                    canPickEntries: true,
                    entryInputs: () => {
                      return [
                        {
                          name: "language",
                          type: "text",
                          enum: languagesEnum
                        }
                      ];
                    },
                    inputs: () => {
                      const acceptableElements = type.elements.filter((element) => ["text"].includes(element.type));
                      const fields = [
                        {
                          name: "limit",
                          defaultValue: 10,
                          min: 0,
                          max: 100,
                          type: "number"
                        },
                        {
                          name: "language",
                          type: "text",
                          enum: languagesEnum
                        }
                      ];
                      if (acceptableElements.length > 0) {
                        fields.push({
                          name: "elements",
                          advanced: true,
                          type: "object",
                          friendlyName: `${type.system.name} elements`,
                          subFields: acceptableElements.map((element) => ({
                            type: element.type,
                            name: element.id,
                            helperText: "Exact match only: see https://kontent.ai/learn/reference/delivery-api/#tag/Filtering-content",
                            friendlyName: element.name
                          }))
                        });
                      }
                      return fields;
                    },
                    toUrl: (options) => {
                      if (options.entry) {
                        const url = client.item(options.entry).getUrl();
                        return url;
                      }
                      const query = client.items().type(type.system.codename);
                      if (options.language) {
                        query.languageParameter(options.language);
                      }
                      if (options.limit) {
                        query.limitParameter(options.limit);
                      }
                      return query.getUrl();
                    }
                  }));
                },
                async getEntriesByResourceType(id, options) {
                  const query = client.items().type(id);
                  const result = await query.toAllPromise();
                  if (options?.resourceEntryId) {
                    const entry = result.data.items.find((item) => item.system.codename === options.resourceEntryId);
                    if (entry) {
                      return [
                        {
                          id: entry.system.codename,
                          name: entry.system.name
                        }
                      ];
                    }
                  } else if (options?.searchText != void 0) {
                    return result.data.items.filter(({ system: { name } }) => name.toLowerCase().includes(options?.searchText?.toLowerCase())).map((item) => ({
                      id: item.system.codename,
                      name: item.system.name
                    }));
                  }
                  return result.data.items.map((entry) => {
                    return {
                      id: entry.system.codename,
                      name: entry.system.name
                    };
                  });
                }
              };
            });

        }
    };
});
//# sourceMappingURL=plugin.system.js.map
